/*
 * Copyright 2008, 2009, 2010 Boris Popov <popov.b@gmail.com>
 */

#include "XMLDocument.hpp"

//-----------------------------------------------
XMLBody::XMLBody ():

	Root (new XMLContain) {
	(Root->place) = XMLNode::in;
	Root->Set ("root");
	return;
}

XMLBody::XMLBody (XMLContain& c) {

	switch (c.place)
	{
		case (XMLNode::in):
		{
			Root = &c;
			break;
		}
		case (XMLNode::out):
		{
			//перегнать во внутреннюю
			//структуру
			//создать контейнер
			Root = new XMLContain;
			Root->Set (c.Get ());
			(Root->place) = XMLNode::in;
			//перенести атрибуты
			if (c.HasItAttr ())
			{
				std::list <XMLAttr>::iterator p;
				p = (c.ListOfAttr).begin ();
				while (p != (c.ListOfAttr).end ())
				{
					(Root->ListOfAttr).push_back (*p);
					p++;
				}
			}
			//перенос указателей///////////////////////////
			//
			//
			if (!c.ListOfChildren.empty ())
			{
				std::list <XMLNode*>::iterator p;
				p = (c.ListOfChildren).begin ();
				while (p != (c.ListOfChildren).end ())
				{
					(Root->ListOfChildren).push_back (*p);
					(*p)->pParent = Root;
					p++;
				}
				c.ListOfChildren.clear ();
			}
			//
			///////////////////////////////////////////////
			break;
		}
		case (XMLNode::undef):
		{
			break;
		}
	}
	return;
}

XMLBody::~XMLBody () {

	delete Root;
	return;
}

XMLBodyIter XMLBody::BeginBodyIter () {

	XMLNode* pN;
	pN = (XMLNode*) Root;
	XMLBodyIter XBI (pN);
	return XBI;
}

XMLBodyIter XMLBody::EndBodyIter () {

	XMLNode* pN = 0;
	XMLBodyIter XBI (pN);
	return XBI;
}

void XMLBody::DelNode (XMLBodyIter& i) {

	XMLNode* pN;
	pN = i.pNode;
	delnode (pN);
	return;
}

void XMLBody::delnode (XMLNode* pN) {

	if (pN == Root)
	{
		std::list <XMLNode*>::iterator p;
		XMLContain* pC = (XMLContain*) pN;
		p = (pC->ListOfChildren).begin ();
		while (p != (pC->ListOfChildren).end ())
		{
			delete (*p);
			p++;
		}
		pC->ListOfChildren.clear ();
	}
	else
	{
		XMLContain* pC;
		pC = pN->pParent;
		std::list <XMLNode*>::iterator p;
		p = (pC->ListOfChildren).begin ();
		while (p != (pC->ListOfChildren).end ())
		{
			if ((*p) == pN)
			{
				break;
			}
			p++;
		}
		(pC->ListOfChildren).erase (p);
		delete pN;
	}
	return;
}

void XMLBody::DelNode (XMLContain& cn) {

	XMLNode* pN;
	pN = (XMLNode*) (&cn);
	delnode (pN);
	return;
}

void XMLBody::DelNode (XMLComment& cm) {

	XMLNode* pN;
	pN = (XMLNode*) (&cm);
	delnode (pN);
	return;
}

void XMLBody::DelNode (XMLText& tx) {

	XMLNode* pN;
	pN = (XMLNode*) (&tx);
	delnode (pN);
	return;
}

void XMLBody::Search (const xpath path,
		XMLSearchResult& result) {

   Root->m_SearchFromRoot (path, result);
   return;
}
		
XMLContain* XMLBody::GetRoot () const {

	return Root;
}
//-----------------------------------------------
