/*
 * Copyright 2008, 2010 Boris Popov <popov.b@gmail.com>
 */

#include "XMLDocument.hpp"

XMLBodyIter::XMLBodyIter (const XMLBodyIter& bi) {

	this->pNode = bi.pNode;
	return;
}

XMLBodyIter&
XMLBodyIter::operator= (const XMLBodyIter& bi) {

	this->pNode = bi.pNode;
	return *this;
}

XMLBodyIter::XMLBodyIter (XMLNode* pN)
{
	pNode = pN;
	return;
}
		
XMLBodyIter::XMLBodyIter ()
{
	return;
}

XMLNode*
XMLBodyIter::operator * ()
{
	return pNode;
}

XMLNode*
XMLBodyIter::operator -> ()
{
	return pNode;
}

XMLBodyIter&
XMLBodyIter::operator ++ ()
{
	if (pNode == 0)
	{
		return *this;
	}
	
	pNode = plus_normal_iter ();
	return *this;
}

XMLNode*
XMLBodyIter::plus_normal_iter ()
{
	XMLNode* pN;
	if ((pNode->GetType ()) == XMLDocument::Container)
	{
		//это только к контейнерам
		XMLContain* pC = (XMLContain*) (pNode);
		if (!((pC->ListOfChildren).empty ()))
		{
			std::list <XMLNode*>::iterator p;
			p = (pC->ListOfChildren).begin ();
			while (p != ((pC->ListOfChildren).end ()))
			{
				Queue.push (*p);
				p++;
			}
		}
	}
	if (!Queue.empty ())
	{
		pN = Queue.front ();
		Queue.pop ();
	}
	else
	{
		pN = 0;
	}
	return pN;
}

XMLBodyIter&
XMLBodyIter::operator ++ (int t)
{
	if (pNode == 0)
	{
		return *this;
	}
	t = 0; //чтоб не ругался компилятор

	pNode = plus_normal_iter ();
	return *this;
}

//===============================================
bool operator != (XMLBodyIter a, XMLBodyIter b)
{
	if (a.pNode != b.pNode)
	{
		return true;
	}
	return false;
}
//===============================================

//===============================================
bool operator == (XMLBodyIter a, XMLBodyIter b)
{
	if (a.pNode == b.pNode)
	{
		return true;
	}
	return false;
}
//===============================================
