/*
 * Copyright 2008, 2009, 2010
 * Boris Popov <popov.b@gmail.com>
 */

#include <XMLDocument.hpp>
#include <XMLMirroring.hpp>
#include <easysax.h>

#ifndef __xmlbuildoftree_hpp__
#define __xmlbuildoftree_hpp__

class XMLDeclar;
class XMLContain;

struct XMLBuildOfTreeResult
{
	XMLDeclar* declar;
	XMLContain* cont;
	std::string* messg;
};

class XMLBuildOfTree
{
	public:
		XMLBuildOfTree ();
		
		void Make_open_teg (const char* t);
		void Make_close_teg (const char* t);
		void Make_text (const char* t);
		void Put_att (AttValue);
		void Put_message (const char* t);
		void Make_decl ();
		XMLBuildOfTreeResult get ();


	private:

		void make_open_teg (std::string t);
		void make_close_teg (std::string t);
		void make_null_teg (std::string t);
		void make_text (std::string t);
		void put_att (std::string a,
				std::string v);
		void make_decl ();


		std::stack <XMLContain*> container;
		std::string message;
		XMLDeclar* xmldeclar;
		XMLContain* root;
		XMLContain* last_container;
		bool zero_xmldeclar;
		bool last_in_declar;
		
		mr::FromMirror m_fMirror;
		bool m_IsItDelimiter (const char ch);
		std::string clear_from_delim (std::string what);
};
#endif
