/*
 * Copyright 2008, 2010 Boris Popov <popov.b@gmail.com>
 */

/*
 *
 * Построитель текстового
 * представления пролога из
 * объектной структуры.
 *
 */

#include "XMLBuilder.hpp"

//-----------------------------------------------
std::string XMLBuilderOfProlog::DECL1 = "<?xml";
std::string XMLBuilderOfProlog::DECL2 = " ?>";
//-----------------------------------------------

//-----------------------------------------------
XMLBuilderOfProlog::XMLBuilderOfProlog (XMLProlog& Prolog) :
	bop (Prolog)
{
	return;
}
//-----------------------------------------------

//-----------------------------------------------
XMLBuilderOfProlog::~XMLBuilderOfProlog ()
{
	return;
}
//-----------------------------------------------

//-----------------------------------------------
std::string
XMLBuilderOfProlog::Get ()
{
	std::string declar;
	declar = get_declar ();
	return declar;
}
//-----------------------------------------------

//-----------------------------------------------
std::string
XMLBuilderOfProlog::get_declar ()
{
	std::string temp;
	XMLDeclar& tempDeclar = bop.GetDeclar ();
	if (tempDeclar.SW == XMLDeclar::OFF)
	{
		return temp;
	}
	std::string attr;
	std::list <XMLAttr>::iterator p;
	p = tempDeclar.ListOfAtt.begin ();
	while (p != tempDeclar.ListOfAtt.end ())
	{
		attr = attr + " " + (*p).att +
			"=\"" + (*p).val +
			"\"";
		p++;
	}
	std::string comment_after_decl;
	temp = DECL1 + attr + DECL2 + "\n";
	return temp;
}
//-----------------------------------------------
