/*
 * Copyright 2008, Boris Popov <popov.b@gmail.com>
 * Copyright 2009, Boris Popov <popov.b@gmail.com>
 */

/*
 *
 * utf-8:
 * Контейнер шагов локализации.
 *
 */

#include "XMLContainerSteps.hpp"

// =========================================== //
xmlxpathcnt::
Container::~Container () {
   
   m_stepList.clear ();
   return;
}
	 
bool
xmlxpathcnt::
Container::GoesFirstStepFromRoot () const {

   bool YES = true;
   bool NO = false;

   if (m_fs == FirstStep_FROM_ROOT) {

      return YES;
   }
   return NO;
}
	 
void
xmlxpathcnt::
Container::Push (xmlxpath::Step& step) {

   m_stepList.push_back (&step);
   return;
}
	 
void
xmlxpathcnt::
Container::GoStart () {

   m_current = m_stepList.begin ();
   m_end = m_stepList.end ();
   return;
}
	 
xmlxpath::Step*
xmlxpathcnt::
Container::Pop () {

   if (m_current != m_end) {
      
      xmlxpath::Step* tempStep =
	 *m_current;
      m_current++;
      return tempStep;
   }
   else {

      return 0;
   }
}


xmlxpathcnt::
Container::Container
(const FirstStep fs) : m_fs (fs) {

   m_stepList.clear ();
   
   #ifdef CONTAINERSTEPS_DEBUG
   std::cerr << std::endl;
   if (fs == 0) {

      std::cerr << "make from root container";
   }
   else {
      
      std::cerr << "make from current container";
   }
   std::cerr << std::endl;
   #endif

   return;
}


void
xmlxpathcnt::
Container::DelFirstStep () {

   IteratorListSteps it;
   it = m_stepList.begin ();
   m_stepList.erase (it);
   return;
}
// =========================================== //
