/*
 * Copyright 2008, Boris Popov <popov.b@gmail.com>
 * Copyright 2009, Boris Popov <popov.b@gmail.com>
 */

/*
 *
 * utf-8:
 * Контейнер шагов локализации.
 *
 */

#include <XMLSteps.hpp>
#include <list>

#ifndef __containersteps__hpp__
#define __containersteps__hpp__

#define CONTAINERSTEPS_NODEBUG
#ifdef CONTAINERSTEPS_DEBUG
#include <iostream>
#endif

namespace xmlxpathcnt {
	 
typedef std::list <xmlxpath::Step*>
   ListSteps;
typedef std::list <xmlxpath::Step*>::
   iterator IteratorListSteps;
   
// =========================================== //
   enum FirstStep {
      
      FirstStep_FROM_ROOT,
      // example: /one/two/three

      FirstStep_FROM_CURRENT
      // example: one/two/three
   };
// =========================================== //

// =========================================== //
   class Container {

      public:

	 Container (FirstStep fs);
	 ~Container ();
	 bool GoesFirstStepFromRoot () const;
	 void Push (xmlxpath::Step& step);
	 xmlxpath::Step* Pop ();
	 void GoStart ();
	 void DelFirstStep ();

      private:
	 const FirstStep m_fs;
	 ListSteps m_stepList;
	 IteratorListSteps m_current;
	 IteratorListSteps m_end;

   };
// =========================================== //

}

#endif
