/*
 * Copyright 2008, 2010 Boris Popov <popov.b@gmail.com>
 */

#include "XMLDocument.hpp"

//-----------------------------------------------
std::string XMLDeclar::part_one = "<?xml ";
std::string XMLDeclar::part_three = "?>";
//-----------------------------------------------

//-----------------------------------------------
XMLDeclar::XMLDeclar () :
	SW (XMLDeclar::ON)
{
	AddAtt ("version", "1.0");
	return;
}
//-----------------------------------------------

//-----------------------------------------------
void
XMLDeclar::AddAtt (std::string a, std::string v)
{
	XMLAttr Attr;
	Attr.att = a;
	Attr.val = v;
	ListOfAtt.push_back (Attr);
}
//-----------------------------------------------

//-----------------------------------------------
XMLDeclar::~XMLDeclar ()
{
	ListOfAtt.clear ();
	return;
}
//-----------------------------------------------

//-----------------------------------------------
std::string
XMLDeclar::GetAtt (std::string a) const
{
	std::string value;
	if (SW == XMLDeclar::OFF)
	{
		return value;
	}
	std::list <XMLAttr>::const_iterator p;
	p = ListOfAtt.begin ();
	while (p != ListOfAtt.end ())
	{
		if ((*p).att == a)
		{
			value = (*p).val;
			break;
		}
		p++;
	}
	return value;
}
//-----------------------------------------------

//-----------------------------------------------
std::string
XMLDeclar::Get ()
{
	std::string all;
	if (SW == XMLDeclar::OFF)
	{
		return all;
	}
	std::string part_two;
	std::list <XMLAttr>::iterator p;
	p = ListOfAtt.begin ();
	while (p != ListOfAtt.end ())
	{
		part_two = part_two + 
			(*p).att + "=\"" + 
			(*p).val + "\" ";
		p++;
	}
	all = part_one + part_two + part_three;
	return all;
}
//-----------------------------------------------

//-----------------------------------------------
void
XMLDeclar::DelAtt (std::string a)
{
	std::list <XMLAttr>::iterator p;
	p = ListOfAtt.begin ();
	while (p != ListOfAtt.end ())
	{
		if ((*p).att == a)
		{
			break;
		}
		p++;
	}
	ListOfAtt.erase (p);
	return;
}
//-----------------------------------------------

//-----------------------------------------------
void
XMLDeclar::UnSet()
{
	SW = XMLDeclar::OFF;
	return;
}
//-----------------------------------------------

//-----------------------------------------------
void
XMLDeclar::Set ()
{
	SW = XMLDeclar::ON;
	ListOfAtt.clear ();
	AddAtt ("version", "1.0");
	return;
}
//-----------------------------------------------

//-----------------------------------------------
XMLAttrIter
XMLDeclar::Begin ()
{
	XMLAttrIter IT;
	IT.IPA = ListOfAtt.begin ();
	return IT;
}
//-----------------------------------------------

//-----------------------------------------------
XMLAttrIter
XMLDeclar::End ()
{
	XMLAttrIter IT;
	IT.IPA = ListOfAtt.end ();
	return IT;
}
//-----------------------------------------------
