/*
 * Copyright 2008, 2009, 2010
 * Boris Popov <popov.b@gmail.com>
 */

#include "XMLParser.hpp"

XMLBuildOfTree* XMLBOT;

//-----------------------------------------------
XMLParser::XMLParser (const char* ch):

m_InputString (ch) {
	
	message = "";
	::XMLBOT = &xbot;
	m_InitResult ();
	return;
}
//-----------------------------------------------

//-----------------------------------------------
XMLParser::~XMLParser ()
{
	return;
}
//-----------------------------------------------

//-----------------------------------------------
void XML_PrintText (Text text) {

	XMLBOT->Make_text (text);
    return;
}

void XML_PrintAtt (AttValue av) {

	XMLBOT->Put_att (av);
    return;
}

void XML_PrintOpen (Text text) {

	XMLBOT->Make_open_teg (text);
    return;
}

void XML_PrintClose (Text text) {

	XMLBOT->Make_close_teg (text);
    return;
}

void XML_PrintD () {

	XMLBOT->Make_decl ();
    return;
}

void XML_PrintE (Text text) {

	XMLBOT->Put_message (text);
    return;
}
//-----------------------------------------------

//-----------------------------------------------
XMLParserResult 
XMLParser::GetFromFile () {
	
	FILE* f = fopen (m_InputString, "rb");
	if (f == NULL) {
		
		m_Result.messg = "Impossible to open file!\n";
		return m_Result;
	}

	CBuffer buffer = InitCBufferFromFD (f);
	if (buffer == NULL) {

		fclose (f);
		m_Result.messg = "Impossible to create a parsing buffer!\n";
		return m_Result;
	}
	
	EasyParser parser = \
    InitEasyParser (buffer, &XML_PrintText, &XML_PrintOpen,
			&XML_PrintClose, &XML_PrintAtt, &XML_PrintD, &XML_PrintE);
	
	if (parser == NULL) {

		m_Result.messg = "Impossible to create a sax parser!\n";
    	DestroyCBuffer (buffer);
		return m_Result;
	}
	
	if (! Parse (parser)) {
        
        XML_PrintE ("Error of sax parsing!\n");
    }
	
	DestroyEasyParser (parser);
    DestroyCBuffer (buffer);
	fclose (f);

	XMLBuildOfTreeResult tr = xbot.get ();
	m_Result.declar = tr.declar;
	m_Result.cont = tr.cont;
	m_Result.messg = message + (*(tr.messg));
	return m_Result;
}

XMLParserResult
XMLParser::Get () {

	CBuffer buffer = InitCBufferFromString (m_InputString);
	if (buffer == NULL) {

		m_Result.messg = "Impossible to create a parsing buffer!\n";
		return m_Result;
	}

	EasyParser parser = \
    InitEasyParser (buffer, &XML_PrintText, &XML_PrintOpen,
			&XML_PrintClose, &XML_PrintAtt, &XML_PrintD, &XML_PrintE);
	
	if (parser == NULL) {

		m_Result.messg = "Impossible to create a sax parser!\n";
    	DestroyCBuffer (buffer);
		return m_Result;
	}
	
	if (! Parse (parser)) {
        
        XML_PrintE ("Error of sax parsing!\n");
    }
	
	DestroyEasyParser (parser);
    DestroyCBuffer (buffer);

	XMLBuildOfTreeResult tr = xbot.get ();
	m_Result.declar = tr.declar;
	m_Result.cont = tr.cont;
	m_Result.messg = message + (*(tr.messg));
	return m_Result;
}

void XMLParser::m_InitResult () {

	m_Result.declar = NULL;
	m_Result.cont = NULL;
	m_Result.messg = "";
	return;
}
//-----------------------------------------------
