/*
 * Copyright 2008, 2009, 2010
 * Boris Popov <popov.b@gmail.com>
 */

#include <easysax.h>
#include <cstdio>
#include <XMLBuildOfTree.hpp>

#ifndef __xmlparser_hpp__
#define __xmlparser_hpp__

struct XMLParserResult
{
	XMLDeclar* declar;
	XMLContain* cont;
	std::string messg;
};

class XMLParser
{
	public:
		XMLParser (const char* ch);
		~XMLParser ();
		XMLParserResult Get ();
		XMLParserResult GetFromFile ();

	private:
		XMLBuildOfTree xbot;
		const char* m_InputString;
		std::string message;

		XMLParserResult m_Result;
		void m_InitResult ();
};
#endif
