/*
 * Copyright 2008, Boris Popov <popov.b@gmail.com>
 * Copyright 2009, Boris Popov <popov.b@gmail.com>
 */

/*
 *
 * utf-8:
 * Шаги локализации.
 *
 */

//#define DEBUG

#include "XMLSteps.hpp"

// =========================================== //
void
xmlxpath::
Step::m_CopyToTemp
(XMLSearchResult& container) {

   XMLSearchResultIter current = container.Begin ();
   XMLSearchResultIter end = container.End ();

   while (current != end) {

      m_tempContainer.push_back (*current);
      current++;
   }
   return;
}

void
xmlxpath::
Step::Get
(XMLSearchResult& container) {
   //main method
   //
   //прохождение ао контейнеру
   //
   //проверится на пустой
   //пришедший контейнер
   if (container.m_container.empty ()) {

      return;
   }

   m_CopyToTemp (container);
   container.Clear ();

   TempContainIterator current;
   TempContainIterator end;

   current = m_tempContainer.begin ();
   end = m_tempContainer.end ();

   while (current != end) {

      m_Compare (current, container);
      current++;
   }

   m_tempContainer.clear ();
   return;
}
// =========================================== //

// =========================================== //
void
xmlxpath::
ChildLexem::m_Compare
(TempContainIterator iter,
 XMLSearchResult& container) {
   //этот метод сильно зависит
   //от типа шага!

   XMLContain* containNode = *iter;
   //пройти по всем детям ContainNode


   if ((containNode->ListOfChildren)
	 .empty ()) {

      return;
   }

   NodeIterator current;
   NodeIterator end;

   current = (containNode->ListOfChildren).begin ();
   end = (containNode->ListOfChildren).end ();

   while (current != end) {

      if (((*current)->GetType ()) ==
	 XMLDocument::Container) {

	 // получаем конкретный
	 // контейнер и сравниваем
	 // с шагом
	 XMLContain* cnt;
	 cnt = (XMLContain*) (*current);
	 m_CompareContainer (cnt, container);
      }
      current++;
   }
   return;
}

void
xmlxpath::
ChildLexem::m_CompareContainer
(XMLContain* cnt, XMLSearchResult& container) {
   //сравнить с шагом, в случае удачи
   //запихнуть в container

   if (cnt == 0) {

      return;
   }

   if (cnt->Get () == m_lexem) {

      if (m_predicat != 0) {

	 if (m_predicat->MatchPredicat (*cnt)) {

	    container.m_container.push_back (cnt);
	 }
      }

      else {
	 container.m_container.push_back (cnt);
      }
   }
   return;
}

xmlxpath::ChildLexem::~ChildLexem () {

   return;
}
   
void
xmlxpath::
ChildLexem::
GetFirstFromRoot
(XMLContain* root, XMLSearchResult& container) {

   if (root == 0) {

      return;
   }

   if ((root->Get ()) == m_lexem) {

      if (m_predicat != 0) {

	 if (m_predicat->MatchPredicat (*root)) {

	    container.m_container.push_back (root);
	 }
      }

      else {

	 container.m_container.push_back (root);
      }
   }
   return;
}
// =========================================== //

// =========================================== //

xmlxpath::ChildLexemAll::~ChildLexemAll () {

   return;
}
   
void
xmlxpath::
ChildLexemAll::
m_Compare
(TempContainIterator iter,
	    XMLSearchResult& container) {
   //этот метод сильно зависит
   //от типа шага!

   XMLContain* containNode = *iter;
   //пройти по всем детям ContainNode


   if ((containNode->ListOfChildren)
	 .empty ()) {

      return;
   }

   XMLBodyIter current = containNode->BeginBodyIter ();
   XMLBodyIter end = containNode->EndBodyIter ();

   while (current != end) {

      if (((*current)->GetType ()) ==
	 XMLDocument::Container) {

	 // получаем конкретный
	 // контейнер и сравниваем
	 // с шагом
	 XMLContain* cnt;
	 cnt = (XMLContain*) (*current);
	 m_CompareContainer (cnt, container);
      }
      current++;
   }
   return;
}
      
void
xmlxpath::
ChildLexemAll::
m_CompareContainer
(XMLContain* cnt, XMLSearchResult& container) {
   
   //сравнить с шагом, в случае удачи
   //запихнуть в container

   if (cnt == 0) {

      return;
   }

   if (cnt->Get () == m_lexem) {

      if (m_predicat != 0) {

	 if (m_predicat->MatchPredicat (*cnt)) {

	    container.m_container.push_back (cnt);
	 }
      }

      else {

	 container.m_container.push_back (cnt);
      }
   }
   return;
}

void
xmlxpath::
ChildLexemAll::
GetFirstFromRoot
(XMLContain* root, XMLSearchResult& container) {

   //проверить рутовый элемент
   //а потом пройти по всем
   //элементам вниз, проверяя
   //соотвествие

   if (root == 0) {

      return;
   }

   if ((root->Get ()) == m_lexem) {

      if (m_predicat != 0) {

	 if (m_predicat->MatchPredicat (*root)) {

	    container.m_container.push_back (root);
	 }
      }

      else {

	 container.m_container.push_back (root);
      }
   }
   
   if ((root->ListOfChildren)
	 .empty ()) {

      return;
   }

   XMLBodyIter current = root->BeginBodyIter ();
   XMLBodyIter end = root->EndBodyIter ();

   while (current != end) {

      if (((*current)->GetType ()) ==
	 XMLDocument::Container) {

	 // получаем конкретный
	 // контейнер и сравниваем
	 // с шагом
	 XMLContain* cnt;
	 cnt = (XMLContain*) (*current);
	 m_CompareContainer (cnt, container);
      }
      current++;
   }

   return;
}
// =========================================== //

// =========================================== //

xmlxpath::ChildAny::~ChildAny () {

   return;
}

void
xmlxpath::
ChildAny::
m_Compare
(TempContainIterator iter,
	    XMLSearchResult& container) {
   //этот метод сильно зависит
   //от типа шага!

      #ifdef DEBUG
	 std::cerr << "CHILDANY...";
      #endif

   XMLContain* containNode = *iter;
   //пройти по всем детям ContainNode


   if ((containNode->ListOfChildren)
	 .empty ()) {

      return;
   }

   NodeIterator current;
   NodeIterator end;

   current = (containNode->ListOfChildren).begin ();
   end = (containNode->ListOfChildren).end ();

   while (current != end) {

      if (((*current)->GetType ()) ==
	 XMLDocument::Container) {

	 // получаем конкретный
	 // контейнер и запихиваем
	 XMLContain* cnt;
	 cnt = (XMLContain*) (*current);
	 
      #ifdef DEBUG
	 std::cerr << "...in..." << cnt->Get ();
      #endif

	 if (m_predicat != 0) {

	    if (m_predicat->MatchPredicat (*cnt)) {

	       container.m_container.push_back (cnt);
	    }
	 }

	 else {
	    container.m_container.push_back (cnt);
	 }
      }
      #ifdef DEBUG
	 std::cerr << "!";
      #endif
      current++;
   }
   return;
}

void
xmlxpath::
ChildAny::
GetFirstFromRoot
(XMLContain* root, XMLSearchResult& container) {

   if (root == 0) {

      return;
   }

   if (m_predicat != 0) {

      if (m_predicat->MatchPredicat (*root)) {
	 
	 container.m_container.push_back (root);
      }
   }

   else {

      container.m_container.push_back (root);
   }
   return;
}
// =========================================== //

// =========================================== //
xmlxpath::ChildAnyAll::~ChildAnyAll () {

   return;
}

void
xmlxpath::
ChildAnyAll::
m_Compare
(TempContainIterator iter,
	    XMLSearchResult& container) {
   //этот метод сильно зависит
   //от типа шага!

   XMLContain* containNode = *iter;
   //пройти по всем детям ContainNode

   if ((containNode->ListOfChildren)
	 .empty ()) {

      return;
   }

   XMLBodyIter current = containNode->BeginBodyIter ();
   XMLBodyIter end = containNode->EndBodyIter ();

   while (current != end) {

      if (((*current)->GetType ()) ==
	 XMLDocument::Container) {

	 // получаем конкретный
	 // контейнер и запихиваем
	 XMLContain* cnt;
	 cnt = (XMLContain*) (*current);

	 if (m_predicat != 0) {

	    if (m_predicat->MatchPredicat (*cnt)) {

	       container.m_container.push_back (cnt);
	    }
	 }

	 else {
	    container.m_container.push_back (cnt);
	 }
      }
      current++;
   }
   return;
}

void
xmlxpath::
ChildAnyAll::
GetFirstFromRoot
(XMLContain* root, XMLSearchResult& container) {

   if (root == 0) {

      return;
   }

   if (m_predicat != 0) {

      if (m_predicat->MatchPredicat (*root)) {

	 container.m_container.push_back (root);
      }
   }

   else {
      container.m_container.push_back (root);
   }
   
   if ((root->ListOfChildren)
	 .empty ()) {

      return;
   }

   XMLBodyIter current = root->BeginBodyIter ();
   XMLBodyIter end = root->EndBodyIter ();

   while (current != end) {

      if (((*current)->GetType ()) ==
	 XMLDocument::Container) {

	 // получаем конкретный
	 // контейнер и запихиваем
	 XMLContain* cnt;
	 cnt = (XMLContain*) (*current);

	 if (m_predicat != 0) {

	    if (m_predicat->MatchPredicat (*cnt)) {

	       container.m_container.push_back (cnt);
	    }
	 }

	 else {

	    container.m_container.push_back (cnt);
	 }
      }
      current++;
   }

   return;
}
// =========================================== //


// =========================================== //
// =========================================== //
xmlxpath::
Predicat_ATT::~Predicat_ATT () {

   return;
}

bool
xmlxpath::
Predicat_ATT::MatchPredicat
(XMLContain& container) const {

   bool result;
   bool OK = true;
   bool FOOL = false;

   result = FOOL;
   
   if (container.HasItAttr ()) {
      
      XMLAttrIter current;
      XMLAttrIter end;

      current = container.BeginAttr ();
      end = container.EndAttr ();

      while (current != end) {

	 if (current.Get ().att == m_attribute) {

	    result = OK;
	    break;
	 }
	 current++;
      }
   }

   else {

      result = FOOL;
   }

   //отработка функции not///////
   if (m_func == FUNC_NOT) {

      FunctionNOT func;
      result = func.Get (result);
   }

   return result;
}
// =========================================== //

// =========================================== //
xmlxpath::
Predicat_ATTALL::~Predicat_ATTALL () {

   return;
}

bool
xmlxpath::
Predicat_ATTALL::MatchPredicat
(XMLContain& container) const {

   bool result;
   result = container.HasItAttr ();

   //отработка функции not///////
   if (m_func == FUNC_NOT) {

      FunctionNOT func;
      result = func.Get (result);
   }

   return result;
}
// =========================================== //

// =========================================== //
xmlxpath::
Predicat_ATTandVAL::~Predicat_ATTandVAL () {

   return;
}

bool
xmlxpath::
Predicat_ATTandVAL::MatchPredicat
(XMLContain& container) const {

   bool result;
   bool OK = true;
   bool FOOL = false;

   result = FOOL;
   
   if (container.HasItAttr ()) {
      
      XMLAttrIter current;
      XMLAttrIter end;

      current = container.BeginAttr ();
      end = container.EndAttr ();

      while (current != end) {

	 if (current.Get ().att == m_attribute) {

	    if (current.Get ().val == m_value) {
	       
	       result = OK;
	       break;
	    }
	 }
	 current++;
      }
   }

   else {

      result = FOOL;
   }

   //отработка функции not///////
   if (m_func == FUNC_NOT) {

      FunctionNOT func;
      result = func.Get (result);
   }/////////////////////////////

   return result;
}
// =========================================== //
// =========================================== //

// =========================================== //
xmlxpath::
FunctionNOT::FunctionNOT () {

   return;
}

xmlxpath::
FunctionNOT::~FunctionNOT () {

   return;
}

bool
xmlxpath::
FunctionNOT::Get (bool in) const {

   if (in) {

      return false;
   }
   else {

      return true;
   }
}
// =========================================== //
