/*
 * Copyright 2008, Boris Popov <popov.b@gmail.com>
 */

#include "XMLStringExtractor.hpp"

// =========================================== //
void
   se::f_ClearMemory (cCString string) {
   delete [] string;
   return;
}

se::StringExtractor::StringExtractor () {
   m_listString.clear ();
   return;
}

se::StringExtractor::~StringExtractor () {
   if (m_listString.empty ()) {
      return;
   }
   IteratorContainerCCStrings begin;
   IteratorContainerCCStrings end;
   begin = m_listString.begin ();
   end = m_listString.end ();
   for_each (begin, end, f_ClearMemory);
   m_listString.clear ();
   return;
}

se::cCString
se::StringExtractor::GetString (cCString string,
	    const Position start,
	    const Position end) {

   cCString ERROR = 0;

   if (string == 0) {
      return ERROR;
   }

   if (end < start) {
      return ERROR;
   }

   Length lengthString = strlen (string);
   if (end > (lengthString - 1)) {
      return ERROR;
   }

   CString myString = new char[end - start + 1 + 1];
   myString[end - start + 1] = '\0';

   Position j = 0;
   for (Position i = start; i < (end +1) ; i++) {
      myString[j] = string[i];
      j++;
   }
   
   m_listString.push_back (myString);
   return myString;
}
// =========================================== //
