/*
 * Copyright 2008, Boris Popov <popov.b@gmail.com>
 */

#ifndef __stringextractor_hpp__
#define __stringextractor_hpp__

#include <cstring>
#include <list>
#include <algorithm>

namespace se {
   
   typedef const char* cCString;
   typedef char* CString;
   typedef size_t Position;
   typedef size_t Length;
   typedef std::list <cCString> ContainerCCStrings;
   typedef std::list <cCString>::iterator
      IteratorContainerCCStrings;
   
   void f_ClearMemory (cCString string);

   class StringExtractor {

      public:
	 StringExtractor ();
	 ~StringExtractor ();
	 cCString GetString (cCString string,
	       const Position start,
	       const Position end);

      private:
	 ContainerCCStrings m_listString;
   };

}

#endif
