/*
 * Copyright 2008, Boris Popov <popov.b@gmail.com>
 * Copyright 2010, Boris Popov <popov.b@gmail.com>
 */
#include "XMLDocument.hpp"
#include "XMLMirroring.hpp"

// =========================================== //
XMLText::XMLText (std::string str) :
	XMLNode (XMLDocument::Text)
{
	place = out;
	Set (str);
	return;
}

XMLText::XMLText () :
	XMLNode (XMLDocument::Text)
{
	place = in;
	return;
}

XMLText::~XMLText ()
{
	return;
}

XMLText&
XMLText::operator = (XMLText& t)
{
   t.Get ();
   return *this;
}

std::string
XMLText::build ()
{
   std::string shift;
   level lev;
   lev = GetLevel ();
   for (level i = 0; i < lev; i++)
   {
      shift = shift + "    ";
   }
   mr::ToMirror tMirror;
   std::string text = Get ();
   return shift + tMirror.Fetch ((text)) + "\n";
}
// =========================================== //
