///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Реализация измерения без учета времени прохождения сигнала
///////////////////////////////////////////////////////////////////////////////
#include "AFreeMeasurement.h"
///////////////////////////////////////////////////////////////////////////////
// Метод определяет время t, которое соответствует моменту излучения 
// сигнала с объекта, а также его положение на орбите в этот 
// момент времени
//-----------------------------------------------------------------------------
bool AFreeMeasurement::DetectPosition(ITraject& trj, TimeJD& t, const IFrame* fr,
                                      Vect6* f) const
{
    t = GetTime();

    if (fr != 0 && f != 0)
        if (!trj.Predict(t, *fr, *f))
            return false;

    return true;
}

///////////////////////////////////////////////////////////////////////////////
