///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Реализация измерения без учета времени прохождения сигнала
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_AFREEMEASUREMENT_H
#define BNOTOOL_AFREEMEASUREMENT_H
///////////////////////////////////////////////////////////////////////////////
#include "IMeasurement.h"

///////////////////////////////////////////////////////////////////////////////
class AFreeMeasurement : public AMeasurement
{
protected:
    // Конструктор
    AFreeMeasurement() : AMeasurement()
    {
    };
    // Метод определяет время t, которое соответствует моменту излучения 
    // сигнала с объекта, а также его положение на орбите в этот 
    // момент времени
    virtual bool DetectPosition(ITraject& trj, TimeJD& t, const IFrame* fr = 0,
                                Vect6* f = 0) const;
};

///////////////////////////////////////////////////////////////////////////////
#endif
