///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Класс координат дальность, прямое восхождение, склонение и скорости их
// изменения
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_ALPHDELD6COORDS_H
#define BNOTOOL_ALPHDELD6COORDS_H
///////////////////////////////////////////////////////////////////////////////
#include "ICoords6D.h"
#include "AlphDelDCoords.h"
#include "FrameConverter.h"
#include "Matrix.h"

///////////////////////////////////////////////////////////////////////////////
class AlphDelD6Coords : public ICoords6D
{
public:
    AlphDelDCoords Coords; // Координаты: alpha, delta, D
    double Dv; // D с точкой (производная от D по времени)
    double DAlpha; // Производная от прямого восхождения по времени
    double DDelta; // Производная от склонения по времени

    // Конструктор по умолчанию
    AlphDelD6Coords();

    // Установка координат по декартовым
    virtual void SetXYZ(const Vect6& src);
    // Получение декартовых координат
    virtual bool GetXYZ(Vect6& dst) const;
    void GetPrtDrv(const Vect6& crd, const FrameConverter6D& frameConveter, DMatrix& prtDrv);
};

///////////////////////////////////////////////////////////////////////////////
#endif
