///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Класс координат дальность, прямое восхождение, склонение
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_ALPHDELDCOORDS_H
#define BNOTOOL_ALPHDELDCOORDS_H
///////////////////////////////////////////////////////////////////////////////
#include "ICoords3D.h"

///////////////////////////////////////////////////////////////////////////////
class AlphDelDCoords : public ICoords3D
{
public:
    double Dist; // Дальность
    double Alpha; // Прямое восхождение [рад]
    double Delta; // Склонение [рад]

    // Конструктор по умолчанию
    AlphDelDCoords();

    // Установка координат по декартовым
    virtual void SetXYZ(const Vect3& src);
    // Получение декартовых координат
    virtual void GetXYZ(Vect3& dst) const;
};

///////////////////////////////////////////////////////////////////////////////
#endif
