///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Стандартные утилиты для угловых величин
///////////////////////////////////////////////////////////////////////////////
#include "Angles.h"

#include <math.h>
///////////////////////////////////////////////////////////////////////////////
// Вычисление разности угловых величин
///////////////////////////////////////////////////////////////////////////////
double AngleDiff(double a1, double a2)
{
    double d = Angle2Pi(a1) - Angle2Pi(a2);
    if (fabs(d) < Pi)
        return d;

    if (d > 0)
        return Pi2 - d;
    else
        return -Pi2 - d;
};
///////////////////////////////////////////////////////////////////////////////
// Приведение угловой величины к диапазону 0 - 2 * Pi
///////////////////////////////////////////////////////////////////////////////
double Angle2Pi(double a)
{
    double r = a;

    while (r > Pi2)
        r -= Pi2;
    while (r < 0.0)
        r += Pi2;

    return r;
}

///////////////////////////////////////////////////////////////////////////////
// Приведение угловой величины к диапазону от -Pi до +Pi
///////////////////////////////////////////////////////////////////////////////
double AnglePiPM(double a)
{
    double r = a;

    while (r > Pi)
        r -= Pi2;
    while (r < -Pi)
        r += Pi2;

    return r;
}

///////////////////////////////////////////////////////////////////////////////
