///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Определение класса описания геоцентрической системы B1950
////////////////////////////////////////////////////////////////////////////////
#include "B1950Frame.h"
////////////////////////////////////////////////////////////////////////////////
// Получение объекта, который соответствует переходу от текущей системы отсчета 
// к системе отсчета J2000 на момент времени t0 (для 3-мерных векторов)
void B1950Frame::Get3DJ2000Converter(const TimeJD& t0, FrameConverter3D& result) const
{
    double* mtx = result.Rotation.GetPtr();

    mtx[0] = 0.9999256794956877;
    mtx[3] = 0.0111814832391717;
    mtx[6] = 0.0048590037723143;
    mtx[1] = -0.0111814832204662;
    mtx[4] = 0.9999374848933135;
    mtx[7] = -0.0000271702937440;
    mtx[2] = -0.0048590038153592;
    mtx[5] = -0.0000271625947142;
    mtx[8] = 0.9999881946023742;

    result.Shift = 0;
};
//------------------------------------------------------------------------------
// Получение объекта, который соответствует переходу от текущей системы отсчета 
// к системе отсчета J2000 на момент времени t0 (для 6-мерных векторов)
void B1950Frame::Get6DJ2000Converter(const TimeJD& t0, FrameConverter6D& result) const
{
    result.Init();
    Get3DJ2000Converter(t0, result.Converter3D);
};
////////////////////////////////////////////////////////////////////////////////
