///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Функции инициализации данных астробаллистической базы
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_COMPLEXINIT_H
#define BNOTOOL_COMPLEXINIT_H
///////////////////////////////////////////////////////////////////////////////
#include "BNOAstroBase.h"
///////////////////////////////////////////////////////////////////////////////
// Инициализация
bool ComplexInit(const char* fname = NULL);
// Инициализация базы с явным указанием времени для эфемерид
bool ComplexInit(const TimeGD& s, const TimeGD& e, const char* fname = NULL);
// Инициализация базы с явным указанием времени для эфемерид
bool ComplexInit(const TimeJD& s, const TimeJD& e, const char* fname = NULL);
// Установка модели атмосферы
void SetAtmosphereModel(TAtmosphereId mi);
// Установка модели гравитации для Земли
bool SetGravityModel(TGravityModelId mi);
// Загрузка данных для эфемерид планеты
bool LoadEphData(TPlanetId pl);
// Выгрузка данных для эфемерид планеты (освобождение памяти)
void UnLoadEphData(TPlanetId pl);
// Получение ссылки на астробаллистическую базу ПК БИКОП
BNOAstroBase* GetBNOAstroBase();
///////////////////////////////////////////////////////////////////////////////
#endif
