///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Утилиты для определения драконического периода и его падения
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_DRPERIOD_H
#define BNOTOOL_DRPERIOD_H
///////////////////////////////////////////////////////////////////////////////
#include "IPredict.h"
#include <string>
///////////////////////////////////////////////////////////////////////////////
// Поиск восходящего узла
///////////////////////////////////////////////////////////////////////////////
bool GetAscNodeYZ(IPredict& prg, const TimeJD& tprim, PhasePoint6D& vect,
                  double (*fParam)(const Vect6&),
                  double (*fvParam)(const Vect6&));
bool GetAscNode(IPredict& prg, PhasePoint6D& vect, const TimeJD& tprim, std::string ascendingNodeRule);
///////////////////////////////////////////////////////////////////////////////
// Определение драконического периода и его падения
///////////////////////////////////////////////////////////////////////////////
bool GetOrbPeriod(IPredict& prg, const TimeJD& t, double& tp, double& dt, std::string ascendingNodeRule);
///////////////////////////////////////////////////////////////////////////////
#endif
