///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Классы гравитационных моделей
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_EARTHGRAVITY_H
#define BNOTOOL_EARTHGRAVITY_H
///////////////////////////////////////////////////////////////////////////////
#include "SGravity.h"
#include "tstring.h"

///////////////////////////////////////////////////////////////////////////////
// Гравитационная модель с гармониками (для Земли)
///////////////////////////////////////////////////////////////////////////////
class EarthGravityModel : public GravityModel
{
public:
    // Конструктор, инициализирующий модель из файла
    EarthGravityModel(TGravityModelId Id, const char* name);
    // Конструктор по умолчанию
    EarthGravityModel() : GravityModel()
    {
        FName = "";
    };

    // Загрузка данных из файла
    bool Load();
    // Нормировка коэффициентов модели
    void toNorm()
    {
        convert(true);
    };
    // Денормировка коэффициентов модели
    void fromNorm()
    {
        convert(false);
    };

    void SetFileName(const char* fname)
    {
        FName = fname;
    };

protected:
    // Конвертирование
    void convert(bool To); // True - to Norm.
    // Имя файла данных
    TString FName;
};

///////////////////////////////////////////////////////////////////////////////
#endif
