///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Интерфейсы шестимерных криволинейных координат (т.е. координаты и скорости)
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_ICOORDS6D_H
#define BNOTOOL_ICOORDS6D_H
///////////////////////////////////////////////////////////////////////////////
#include "DVectors.h"

///////////////////////////////////////////////////////////////////////////////
class ICoords6D
{
public:
    virtual ~ICoords6D()
    {
    };

    // Установка координат и скоростей по декартовым
    virtual void SetXYZ(const Vect6& src) = 0;
    // Получение декартовых координат и скоростей
    virtual bool GetXYZ(Vect6& dst) const = 0;
};

///////////////////////////////////////////////////////////////////////////////
#endif
