///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Интерфейс процедуры исключения измерений из обработки
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_IMEASUREMENTFILTER_H
#define BNOTOOL_IMEASUREMENTFILTER_H
///////////////////////////////////////////////////////////////////////////////
#include "IMeasurement.h"

class IMeasurementFilter
{
public:
    // Метод принимает в качестве входных параметров ссылку на одиночное измерение m
    virtual ~IMeasurementFilter()
    {
    };
    // Метод принимает в качестве входных параметров ссылку на одиночное измерение m
    // и вектор невязок по измеренным параметрам
    // Метод возвращает true, если переданное измерение должно быть исключено из обработки,
    // и false - в противном случае
    virtual bool IsDeactivate(const IMeasurement& m, const DVector& del) const = 0;
    // Метод возращает тип измерения, для которого предназначен фильтр
    // Если фильтр может обрабатывать измерения разных типов, то он
    // возвращает mtUnknown
    virtual int GetType() const
    {
        return mtUnknown;
    };
};

///////////////////////////////////////////////////////////////////////////////
#endif
