///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Интерфейс пакета измерений
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_IMEASUREMENTSET_H
#define BNOTOOL_IMEASUREMENTSET_H
///////////////////////////////////////////////////////////////////////////////
#include "IMeasurement.h"

///////////////////////////////////////////////////////////////////////////////
class IMeasurementSet
{
public:
    // Деструктор
    virtual ~IMeasurementSet()
    {
    };
    // Встать на начало измерений.
    virtual void Rewind() = 0;
    // Получить число измерений.
    virtual unsigned GetSize() const = 0;
    // Получить указатель на первый элемент пакета
    virtual IMeasurement* GetFirst() = 0;
    // Получить указатель на очередной элемент пакета или 0
    virtual IMeasurement* GetNext() = 0;
};

///////////////////////////////////////////////////////////////////////////////
#endif
