///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Реализация модели КО с постоянными баллистическим коэффициентом и 
// коэффициентом светового давления
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_KOCONST_H
#define BNOTOOL_KOCONST_H
///////////////////////////////////////////////////////////////////////////////
#include "IKOProp.h"

///////////////////////////////////////////////////////////////////////////////
class KOConst : public IKOProp
{
public:
    // Баллистический коэффициент
    double Kb;
    // Коэффициент светового давления
    double Kappa;

    // Вычисление полного вектора ускорения в J2000
    virtual void GetAcc(const AccAdapter& p, Vect3& acc) const;
    // Вычисление ускорения от светового давления
    virtual double LightAcc(const AccAdapter& p, Vect3& acc) const;
    // Вычисление атмосферного ускорения
    virtual void AtmAcc(const AccAdapter& p, Vect3& acc) const;
};

///////////////////////////////////////////////////////////////////////////////
#endif
