///////////////////////////////////////////////////////////////////////////////
// Библиотека программных инструментов
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Класс двухсвязанного списка для символьных элементов "ключ-значение"
///////////////////////////////////////////////////////////////////////////////
#include "Defines.h"
#include "KVList.h"
#include <cstring>
///////////////////////////////////////////////////////////////////////////////
// Добавление элемента в список
void TKVList::Add(const char* key, const char* value)
{
    TKVEntry* e = new TKVEntry;
    e->Key = key;
    e->Value = value;
    insert_last(e, 0);
}

//-----------------------------------------------------------------------------
// Поиск элемента по ключу
TKVEntry* TKVList::Find(const char* key) const
{
    TKVEntry* e;

    for (e = first(); e != NULL; e = e->next()) {
        if (!strcasecmp(key, e->Key))
            return e;
    }

    return NULL;
}

//-----------------------------------------------------------------------------
// Получение значения по ключу
const char* TKVList::GetValue(const char* key)
{
    TKVEntry* e = Find(key);
    if (e == NULL)
        return NULL;

    return e->Value;
}

///////////////////////////////////////////////////////////////////////////////
