///////////////////////////////////////////////////////////////////////////////
// Библиотека программных инструментов
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Класс двухсвязанного списка для символьных элементов "ключ-значение"
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_KVLIST_H
#define BNOTOOL_KVLIST_H
///////////////////////////////////////////////////////////////////////////////
#include "twll.h"
#include "tstring.h"

///////////////////////////////////////////////////////////////////////////////
// Элемент с ключом и значением
///////////////////////////////////////////////////////////////////////////////
class TKVItem
{
public:
    TString Key;
    TString Value;
};

///////////////////////////////////////////////////////////////////////////////
// Элемент связанного списка с ключом и значением
///////////////////////////////////////////////////////////////////////////////
typedef Twll_Entry_Class<TKVItem> TKVEntry;

///////////////////////////////////////////////////////////////////////////////
// Сам список
///////////////////////////////////////////////////////////////////////////////
class TKVList : public Twll_List_Class<TKVEntry>
{
public:
    // Добавление элемента в список
    void Add(const char* key, const char* value);
    // Поиск элемента по ключу
    TKVEntry* Find(const char* key) const;
    // Получение значения по ключу
    const char* GetValue(const char* key);
};

///////////////////////////////////////////////////////////////////////////////
#endif
