///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Реализация прогноза по законам Кеплера
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_KEPLPREDICT_H
#define BNOTOOL_KEPLPREDICT_H
///////////////////////////////////////////////////////////////////////////////
#include "IPredict.h"
#include "Kepler.h"

///////////////////////////////////////////////////////////////////////////////
class KeplPredict : public IPredict
{
public:
    // Конструктор по умолчанию 
    KeplPredict()
    {
        FlagInit = false;
    };
    //
    virtual ~KeplPredict()
    {
    };
    // Установка начальных условий для прогноза
    void SetInitPoint(const PhasePoint6D& src);
    // Собственно прогнозирование
    virtual bool Run(const TimeJD& t);
    // Получение конечной точки
    virtual void GetDestPoint(PhasePoint6D& dest);
    virtual void GetDestPointEX(Vect6& pos);
protected:
    //  Начальные условия в виде элементов Кеплера в J2000
    Kepler Kepl0;
    // Начальное время
    TimeJD T0;
    // Флаг установки начальных условий
    bool FlagInit;
    // Конечный момент прогноза
    TimeJD Tk;
};

///////////////////////////////////////////////////////////////////////////////
#endif
