///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Класс, реализующий произвольную прямоугольную матрицу
///////////////////////////////////////////////////////////////////////////////
#include "Matrix.h"
///////////////////////////////////////////////////////////////////////////////
// Транспонирование
//-----------------------------------------------------------------------------
void DMatrix::Transpose()
{
    TAssert(Matrix != NULL);

    double** ptr = Matrix;
    Matrix = CreatePtr(NCols, NRows);
    if (Matrix == NULL) {
        delete[] ptr;
        return;
    }

    unsigned i, j;
    double* line;

    for (i = 0; i < NCols; i++) {
        line = Matrix[i];
        for (j = 0; j < NRows; j++)
            line[j] = ptr[j][i];
    }

    unsigned st = NRows;
    NRowsMem = NRows = NCols;
    NColsMem = NCols = st;
    BufSize = ReqSize(NRows, NCols);
    delete[] ptr;

    return;
}

//-----------------------------------------------------------------------------
// Реализация запроса значений элементов в виде массива
//-----------------------------------------------------------------------------
void DMatrix::GetArray(double* array) const
{
    TAssert(Matrix != NULL);
    TAssert(array != NULL);

    unsigned i;

    for (i = 0; i < NRows; i++) {
        memcpy(array, Matrix[i], NCols * sizeof(double));
        array += NCols;
    }
}

//-----------------------------------------------------------------------------
// Реализация запроса значений столбца
//-----------------------------------------------------------------------------
void DMatrix::GetCol(unsigned index, double* col) const
{
    TAssert(Matrix != NULL);
    TAssert(index < NCols);
    TAssert(col != NULL);

    unsigned i;

    for (i = 0; i < NRows; i++)
        col[i] = Matrix[i][index];
}

///////////////////////////////////////////////////////////////////////////////
