///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Класс, моделирующий оптические измерения в системе J2000 c учетом времени 
// прохождения сигнала.
///////////////////////////////////////////////////////////////////////////////
#include "OpticDelayMeasurementJ2000.h"
///////////////////////////////////////////////////////////////////////////////
void OpticDelayMeasurementJ2000::SetStationCoords(const Vect3& pos)
{
    OpticDelayMeasurement::SetStationCoords(pos);
    GeoCoordsPrec lfh;

    lfh.SetXYZ(pos);
    MFrame.Init(lfh);
}

//-----------------------------------------------------------------------------
// Создать копию объекта с помощью new()
//-----------------------------------------------------------------------------
IMeasurement* OpticDelayMeasurementJ2000::Clone() const
{
    OpticDelayMeasurementJ2000* m = new OpticDelayMeasurementJ2000;
    *m = *this;
    return m;
}

///////////////////////////////////////////////////////////////////////////////
