///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Класс, моделирующий оптические измерения в системе J2000 c учетом времени 
// прохождения сигнала.
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_OPTICDELAYMEASUREMENTJ2000_H
#define BNOTOOL_OPTICDELAYMEASUREMENTJ2000_H
///////////////////////////////////////////////////////////////////////////////
#include "OpticDelayMeasurement.h"
#include "LocalJ2000Frame.h"

///////////////////////////////////////////////////////////////////////////////
class OpticDelayMeasurementJ2000 : public OpticDelayMeasurement
{
public:
    // Конструктор по умолчанию

    OpticDelayMeasurementJ2000() : OpticDelayMeasurement()
    {
    };
    // Деструктор
    virtual ~OpticDelayMeasurementJ2000()
    {
    };
    // Установка положения станции в Гринвиче
    virtual void SetStationCoords(const Vect3& pos);
    // Метод возвращает указатель на систему отсчета, используемую в измерении
    virtual const IFrame* GetSrcFrame() const
    {
        return &MFrame;
    };
    // Создать копию объекта с помощью new()
    virtual IMeasurement* Clone() const;

protected:
    // СО, в которой выполняются измерения
    LocalJ2000Frame MFrame;
};

///////////////////////////////////////////////////////////////////////////////
#endif
