///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Класс координат дальность, азимут, угол места
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_RAZGAMCOORDS_H
#define BNOTOOL_RAZGAMCOORDS_H
///////////////////////////////////////////////////////////////////////////////
#include "ICoords3D.h"
#include "ICoords6D.h"

///////////////////////////////////////////////////////////////////////////////
class RAzGammaCoords : public ICoords3D
{
public:
    double Dist; // Дальность
    double Az; // Азимут [рад]
    double Gamma; // Угол места [рад]

    // Конструктор по умолчанию
    RAzGammaCoords();

    // Установка координат по декартовым
    virtual void SetXYZ(const Vect3& src);
    // Получение декартовых координат
    virtual void GetXYZ(Vect3& dst) const;
};

///////////////////////////////////////////////////////////////////////////////
class RAzGamma6Coords : public ICoords6D
{
public:
    RAzGammaCoords Coords;
    double DElevation;
    double DAzimuth;
    double Velocity;

    // Конструктор по умолчанию
    RAzGamma6Coords();

    // Установка координат по декартовым
    virtual void SetXYZ(const Vect6& src);
    // Получение декартовых координат
    virtual bool GetXYZ(Vect6& dst) const;
};

///////////////////////////////////////////////////////////////////////////////
#endif
