///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Определение класса системы отсчета RNB
////////////////////////////////////////////////////////////////////////////////
#include "RNBFrame.h"
////////////////////////////////////////////////////////////////////////////////
// Получение объекта, который соответствует переходу от текущей системы отсчета
// к системе отсчета J2000 на момент времени t0 (для 3-мерных векторов)
void RNBFrame::Get3DJ2000Converter(const TimeJD& t0, FrameConverter3D& result) const
{
    TAssert(Pars.IsInit());
    result.Shift = Pars.GetPoint();
    Pars.GetMatrix().Transp(result.Rotation);
}

//------------------------------------------------------------------------------
// Получение объекта, который соответствует переходу от текущей системы отсчета
// к системе отсчета J2000 на момент времени t0 (для 6-мерных векторов)
void RNBFrame::Get6DJ2000Converter(const TimeJD& t0, FrameConverter6D& result) const
{
    result.Init();
    Get3DJ2000Converter(t0, result.Converter3D);
}

//------------------------------------------------------------------------------
// Установка параметров системы
void RNBFrame::SetParameters(const IFrameParameters& p)
{
    TAssert(p.GetFrameType() == csIdRNB);
    const RNBFrameParameters& pm = (const RNBFrameParameters &)p;
    Pars = pm;
}

////////////////////////////////////////////////////////////////////////////////
