///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Представление времени и временных шкал
///////////////////////////////////////////////////////////////////////////////
#include "TM.h"
#include "IAstroBase.h"
///////////////////////////////////////////////////////////////////////////////
// Функции конвертирования представления времени
///////////////////////////////////////////////////////////////////////////////
void convertTime(const TimeTLE& tle, TimeJD& jd)
{
    int d;
    double f;

    convertTimeTJ(tle.Year, tle.Day, d, f);
    GetAstroBase()->ConvertTimeScaleJD(tmScaleUTC, tmScaleTDB, d, f);
    jd.Init(d, f);
}

//-----------------------------------------------------------------------------
void convertTime(const TimeJD& jd, TimeTLE& tle)
{
    int y, jds = jd.GetDays();
    double d, jf = jd.GetFraction();

    GetAstroBase()->ConvertTimeScaleJD(tmScaleTDB, tmScaleUTC, jds, jf);
    convertTimeJT(jds, jf, y, d);
    tle.Init(y, d);
}

//-----------------------------------------------------------------------------
void convertTime(const TimeGD& grd, TimeJD& jd)
{
    int d;
    double f;

    convertTimeGJ(grd.Year, grd.Month, grd.Day, grd.Hour, grd.Min, grd.Sec,
                  grd.Fraction, d, f);

    GetAstroBase()->ConvertTimeScaleJD(tmScaleUTC, tmScaleTDB, d, f);
    jd.Init(d, f);
}

//-----------------------------------------------------------------------------
void convertTime(const TimeJD& jd, TimeGD& grd)
{
    int y, jds = jd.GetDays();
    unsigned short month, day, hour, mnt, sec;
    double f, jf = jd.GetFraction();

    GetAstroBase()->ConvertTimeScaleJD(tmScaleTDB, tmScaleUTC, jds, jf);
    convertTimeJG(jds, jf, y, month, day, hour, mnt, sec, f);
    grd.Init(day, month, y, hour, mnt, sec, f);
}

///////////////////////////////////////////////////////////////////////////////
