///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Представление времени и временных шкал
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_TMSTR_H
#define BNOTOOL_TMSTR_H
///////////////////////////////////////////////////////////////////////////////
// Константы и переменные, определяющие формат представления времен 
// в символьном виде
///////////////////////////////////////////////////////////////////////////////
extern unsigned short int JLDATE_STR_LEN;
#define GRDATE_STR_LEN 11
extern unsigned short int GRTIME_STR_LEN;
#define GRDTIME_STR_LEN (GRDATE_STR_LEN+GRTIME_STR_LEN)
extern unsigned short int TLEDATE_STR_LEN;
///////////////////////////////////////////////////////////////////////////////
// Функции, управляющие форматом печати дат
///////////////////////////////////////////////////////////////////////////////
// возвращает количество знаков в печати времени, отводимых на вывод долей секунд
unsigned int GetTimePrecision();
// устанавливает количество знаков в печати времени, отводимых на вывод долей секунд
void SetTimePrecision(unsigned int timePrec);
///////////////////////////////////////////////////////////////////////////////
// Функции проверки правильности форматов дат и временных шкал
///////////////////////////////////////////////////////////////////////////////
bool IsJulianDate(const char* str); // Is valid Julian Date?
bool IsGrigorianDate(const char* str); // Is valid Grigorian Date?
bool IsDTime(const char* str); // Is valid time of the day?
bool IsTLEDate(const char* str); // Is valid TLE date?
bool IsTScale(const char* str); // Is valid time scale?
///////////////////////////////////////////////////////////////////////////////
#endif
