///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Представление времени и временных шкал
///////////////////////////////////////////////////////////////////////////////
#ifndef BNOTOOL_TMUTIL_H
#define BNOTOOL_TMUTIL_H
///////////////////////////////////////////////////////////////////////////////
// Вспомогательные функции для пересчета форматов представления времени
///////////////////////////////////////////////////////////////////////////////
// Нормализация представления Юлианской даты
void normalizeJD(int& d, double& f);
// Конвертирование юлианской даты в григорианскую
void convertTimeJG(int jd, double jf, int& year, unsigned short int& month,
                   unsigned short int& day, unsigned short int& hour,
                   unsigned short int& mint, unsigned short int& sec,
                   double& fraction);
// Конвертирование григорианской даты в юлианскую
void convertTimeGJ(int year, unsigned short int month,
                   unsigned short int day, unsigned short int hour,
                   unsigned short int mint, unsigned short int sec,
                   double fraction, int& jd, double& jf);
// Конвертирование юлианской даты в формат TLE
void convertTimeJT(int ds, double fraction, int& year, double& day);
// Конвертирование формата TLE в юлианскую дату
void convertTimeTJ(int year, double day, int& ds, double& fraction);
///////////////////////////////////////////////////////////////////////////////
#endif
