///////////////////////////////////////////////////////////////////////////////
// Библиотека алгоритмов небесной механики
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Класс представления времени в виде Юлианской даты
///////////////////////////////////////////////////////////////////////////////
#include "TM.h"
#include "IAstroBase.h"
///////////////////////////////////////////////////////////////////////////////
// Операторы класса TimeJD
///////////////////////////////////////////////////////////////////////////////
TmDay operator-(const TimeJD& dt, const TimeJD& dt2)
{
    TmDay ret;
    ret.Init((double)(dt.Days - dt2.Days));
    ret += TmDay(dt.Fraction - dt2.Fraction);
    return ret;
}

//-----------------------------------------------------------------------------
bool operator<(const TimeJD& t1, const TimeJD& t2)
{
    if (t1.Days != t2.Days)
        return (t1.Days < t2.Days);
    return (t1.Fraction < t2.Fraction);
}

//-----------------------------------------------------------------------------
bool operator==(const TimeJD& t1, const TimeJD& t2)
{
    return (t1.Days == t2.Days) && (t1.Fraction == t2.Fraction);
}
