#ifndef _sgp4ext_h_
#define _sgp4ext_h_

/*     ----------------------------------------------------------------


                                sgp4ext.h


    this file contains fundamental astrodynamic procedures and functions
    relating to the time functions. these routines are discussed in ch
    3 and ch 5.

                            companion code for
               fundamentals of astrodyanmics and applications
                                    2001
                              by david vallado

       (h)               email valladodl@worldnet.att.net
       (w) 719-573-2600, email dvallado@agi.com

       *****************************************************************

    current :
              17 jun 04  david vallado
                           3rd edition baseline
    changes :
              14 may 01  david vallado
                           2nd edition baseline
              23 nov 87  david vallado
                           original baseline

       ----------------------------------------------------------------

                                  interface

       ----------------------------------------------------------------      */

//#include "astutil.h"

/*
 * object definitions
*/
typedef char* str3;
typedef char* str10;
typedef char* str11;
typedef char* str12;

typedef enum { from, too } direction;

/*
 * global interfaces
*/
void days2mdhms(int, double,
                int&, int&, int&, int&, double&);

void finddays(int, int, int, int, int, double, double&);

double gstime(double);

void invjday(double, int&, int&, int&, int&, int&,
             double&);

void julianday(int, int, int, int, int, double, double&);

void lstime(double, double, double&, double&);

void newtonm(double, double, double&, double&);

double modfunc(double x, double y);
double sgn(double x);


#endif
