///////////////////////////////////////////////////////////////////////////////
// Библиотека программных инструментов
// (с) ИПМ им.М.В.Келдыша, ЗАО "Проекттехника"
///////////////////////////////////////////////////////////////////////////////
// Реализация сортировки для динамических двухсвязанных списков
///////////////////////////////////////////////////////////////////////////////
#include    "twll.h"
#include    <string.h>
///////////////////////////////////////////////////////////////////////////////
void CTwll_BList_Class::sort(int compare(TWLL_BENTRY_CLASS*, TWLL_BENTRY_CLASS*))
{
    unsigned n, k, i;
    TWLL_BENTRY_CLASS *e1, *e2, *r1, *r2, *p;

    n = size();
    if (n <= 1)
        return;

    for (k = 0; n != 1; k++)
        n >>= 1;
    k = 1 << k;

    while (k > 0) {
        e1 = pfirst;
        e2 = set_number(k);
        while (e2 != NULL) {
            if (compare(e1, e2) > 0) {
                swap(e1, e2);
                p = e1;
                e1 = e2;
                e2 = p;
                r2 = e1;
                for (; ;) {
                    for (i = 0, r1 = r2; i < k && r1 != NULL; i++, r1 = r1->prev);
                    if (!r1)
                        break;
                    if (compare(r1, r2) <= 0)
                        break;
                    swap(r1, r2);
                    if (r2 == e1)
                        e1 = r1;
                }
            }
            e1 = e1->next;
            e2 = e2->next;
        }
        k >>= 1;
    }

    return;
}

///////////////////////////////////////////////////////////////////////////////
void CTwll_BList_Class::swap(TWLL_BENTRY_CLASS* a0, TWLL_BENTRY_CLASS* a1)
{
    TWLL_BENTRY_CLASS *p, *n, *r;

    p = a0->prev;
    if (!p)
        pfirst = a1;
    else
        p->next = a1;

    n = a1->next;
    if (!n)
        plast = a0;
    else
        n->prev = a0;

    if (a0->next == a1) {
        a0->prev = a1;
        a1->next = a0;
    }
    else {
        r = a0->next;
        r->prev = a1;
        a1->next = r;
        r = a1->prev;
        r->next = a0;
        a0->prev = r;
    }

    a1->prev = p;
    a0->next = n;

    return;
}

///////////////////////////////////////////////////////////////////////////////
TWLL_BENTRY_CLASS* CTwll_BList_Class::set_number(int k)
{
    int i;
    TWLL_BENTRY_CLASS* cur;

    for (i = 0, cur = pfirst; i < k; i++)
        cur = cur->next;

    return (cur);
}

///////////////////////////////////////////////////////////////////////////////
