///////////////////////////////////////////////////////////////////////////////
// Библиотека небесной механики
// (с) ЗАО "КИА Системы", 2005 г.  
///////////////////////////////////////////////////////////////////////////////
// Представление временных диапазонов с их границами
///////////////////////////////////////////////////////////////////////////////
#include "time_range.h"
///////////////////////////////////////////////////////////////////////////////
#define LONG_DATE_AROUND (1.0e-10L) // Допустимая погрешность при сравнении дат
///////////////////////////////////////////////////////////////////////////////
// Инициализация с указанием границ
void TIME_RANGE::Init(TimeJD const& beginning, TimeJD const& in_end)
{
    init_flag = true;
    beg = beginning;
    end = in_end;
    TAssert(beg <= end);
}

//-----------------------------------------------------------------------------
// Очистка
void TIME_RANGE::init()
{
    init_flag = false;
    beg = MINJDDATE;
    end = MAXJDDATE;
}

//-----------------------------------------------------------------------------
bool TIME_RANGE::less_or_equal(TimeJD const& __beg, TimeJD const& __date) const
{
    if (fabs((long double)((__beg - __date).GetDouble())) <= LONG_DATE_AROUND)
        return true;
    if (__beg < __date)
        return true;
    return false;
}

//-----------------------------------------------------------------------------
bool TIME_RANGE::greater_or_equal(TimeJD const& __beg, TimeJD const& __date) const
{
    if (fabs((long double)((__beg - __date)).GetDouble()) <= LONG_DATE_AROUND)
        return true;
    if (__beg > __date)
        return true;
    return false;
}

///////////////////////////////////////////////////////////////////////////////
