#ifndef QUALITYORBIT_H
#define QUALITYORBIT_H

#include <vector>
#include "QualityOrbitRnbUnit.h"
#include "TM.h"
#include "StateVector.h"
#include <iostream>

class QualityOrbit
{
public:
	QualityOrbit(){};
	void SetDate(double interval, TimeJD date);
	void AddValues(double dispR, double dispN, double dispB);
	void CalculateStatistics();
    void Calculate(const SInitOrbit& orbit);
	void ToXml(std::ostream& outs) const;
	const QualityRnbUnit& GetR() const {return m_r;}
	const QualityRnbUnit& GetN() const {return m_n;}
	const QualityRnbUnit& GetB() const {return m_b;}
private:	
	double m_interval;
	TimeJD m_date;
	QualityRnbUnit m_r;
	QualityRnbUnit m_n;
	QualityRnbUnit m_b;
};

#endif
