#include "QualityOrbitRnbUnit.h"
#include "MeasStatisticsCalculator.h"
#include <algorithm>
#include <functional>
#include "XMLFunctions.h"

void QualityRnbUnit::AddValue( double value )
{
	m_vec.push_back(value);
}

void QualityRnbUnit::CalculateStatistics()
{
	std::sort(m_vec.begin(), m_vec.end(), std::less<double>());
	double sigma, mean, median;
	CalcVectorMeanAndSigma(m_vec,m_sigma,m_mean);
	m_max = m_vec.back();
	m_min = m_vec.front();
}

void QualityRnbUnit::ToXml(std::ostream& outs) const
{
	PutValue(outs,"Mean",m_mean);
	PutValue(outs,"Sigma",m_sigma);
	PutValue(outs,"Max",m_max);
	PutValue(outs,"Min",m_min);
}
