#include "EarthModel.h"
#include "XMLFunctions.h"
#include <map>
#include <utility>

EarthModel::EarthModel() = default;

EarthModel::EarthModel(std::string model, int m, int n)
    :
    m_harmonicsM(m),
    m_harmonicsN(n),
    m_model(std::move(model))
{
}

bool EarthModel::Load(myXML::Contain* parent)
{
    std::map<std::string, myXML::Contain*> con;
    GetChildren(parent, con);

    LoadXML(con, "Model", m_model);
    LoadXML(con, "HarmonicsM", m_harmonicsM);
    LoadXML(con, "HarmonicsN", m_harmonicsN);

    return true;
}


void EarthModel::load(const jsonval& parent)
{
    loadjson(parent, "model", m_model);
    loadjson(parent, "m", m_harmonicsM);
    loadjson(parent, "n", m_harmonicsN);
}
