#ifndef KEPDATA_H
#define KEPDATA_H 

#include <myXML_Document.hpp>
#include "json_functions.h"
#include "Kepler.h"

class KepData
{
public:
    KepData()
    {
    };

    virtual ~KepData()
    {
    };
    void Init(const Kepler& kep);
    bool Load(myXML::Contain* parent);
    void load(const jsonval& parent);
    double GetSemimajorAxis() const { return m_sma; }
    double GetEccentricity() const { return m_ecc; }
    double GetInclination() const { return m_incl; }
    double GetArgOfPerigee() const { return m_aop; }
    double GetArgOfLatitude() const { return m_aol; }
    double GetRAAN() const { return m_raan; }
    double GetPeriod() const { return m_period; }
    double GetHPerigee() const { return m_hPerigee; }
    double GetHApogee() const { return m_hApogee; }
    double GetRPerigee() const { return m_rPerigee; }
    double GetRApogee() const { return m_rApogee; }
    void ToXml(std::ostream& outs) const;
protected:
    double m_sma;
    double m_ecc;
    double m_incl;
    double m_aop;
    double m_aol;
    double m_raan;
    double m_period;
    double m_hApogee;
    double m_hPerigee;
    double m_rApogee;
    double m_rPerigee;
};

#endif
