#ifndef MEXCEPTION_H
#define MEXCEPTION_H

#include <exception>
#include <string>
#include <sstream>

class Exp : public std::exception
{
private:
    std::string msg;
public:
    Exp()
    {
    };

    Exp(const Exp& rhs)
    {
        msg = rhs.msg;
    }

    virtual ~Exp() throw()
    {
    };

    virtual const char* what() const throw()
    {
        return msg.c_str();
    }

    template <typename T>
    Exp& operator<<(const T& t)
    {
        std::stringstream ss;
        ss << t;
        msg += ss.str();
        return *this;
    }
};

#endif
