#pragma once 

#include "json_functions.h"

class MagData
{
public:
    MagData();
    void SetOpticData(double stdphase_deg, double stdtrange_km, double stdmag);
    void SetGeomData(double rcs, double albedo);
    void load(const jsonval& parent);
    double GetMag() const { return m_mag; }
    double GetRcs() const { return m_rcs; }
    bool HasData() const { return m_hasData; }
    bool HasGeomData() const { return m_hasGeomData; }
    void CalcMag(double phase_rad, double range_tkm);
    void CalcGeomMag(double phase_rad, double range_tkm);
    double get_std_mag() const { return m_stdmag; }
    double get_std_phase() const { return m_stdphase_rad; }
    double get_std_range() const { return m_stdrange_tkm; }
    void override_stdmag(double stdmag);
private:
    static double CalcA0g(double stdmag, double stdphase_rad, double stdrange_tkm, double sunMag);
    static double CalcRealMag(double A0g, double sunMag, double phase_rad, double range_tkm);

    double m_stdmag;
    double m_stdphase_rad{0};
    double m_stdrange_tkm{40};
    double m_phase_rad;
    double m_range_tkm;
    double m_mag;
    double m_rcs;
    double m_albedo;
    bool m_hasData{false};
    bool m_hasGeomData{false};
};
