#include "ObjectInfo.h"
#include <map>
#include "XMLFunctions.h"

ObjectInfo::ObjectInfo()
    : m_loaded(false)
{
}

bool ObjectInfo::Load(myXML::Contain* parent)
{
    m_loaded = false;
    m_officialName = "";

    std::map<std::string, myXML::Contain*> map;
    GetChildren(parent, map);

    LoadXML(map, "Id", m_id);
    LoadXML(map, "Catnum", m_catnum);
    LoadXML(map, "Nipm", m_nipm);
    LoadXML(map, "Intdes", m_intdes);
    LoadXML(map, "OfficialName", m_officialName, false);

    m_loaded = true;
    return true;
}

void ObjectInfo::GetAsXML(std::ostream& outs) const
{
    PutValue(outs, "Id", m_id);
    PutValue(outs, "Catnum", m_catnum);
    PutValue(outs, "Nipm", m_nipm);
    PutValue(outs, "Intdes", m_intdes);
    PutValue(outs, "OfficialName", m_officialName);
}

void ObjectInfo::ToXml(std::ostream& outs) const
{
    GetAsXML(outs);
}
