#include "SGPTrj.h"
#include "PhasePoint.h"
#include "METEFrame.h"

SGPTrj::SGPTrj() : InitTime(0, 0.0)
{
}

//-----------------------------------------------------------------------------
// Метод устанавливает значение вектора уточняемых параметров
//-----------------------------------------------------------------------------
bool SGPTrj::Init(const TLESet& tle)
{
    GetPredictor()->Init(tle);

    return true;
}

bool SGPTrj::Init(const DVector& u0)
{
    return true;
}

bool SGPTrj::Predict(const TimeJD& t, const IFrame& fr, Vect6& f)
{
    if (!Predictor.Run(t))
        return false;

    PhasePoint6D pr(666);
    Predictor.GetDestPoint(pr);
    pr.Convert(fr);
    f = pr.CoordsVel;

    return true;
}

bool SGPTrj::Move(const TimeJD& t, DVector& u)
{
    if (!Predictor.Run(t))
        return false;

    unsigned n = 6;

    u.Init(n);

    PhasePoint6D ph;

    Predictor.GetDestPoint(ph);
    int i;

    for (i = 0; i < 6; i++)
        u[i] = ph.CoordsVel[i];

    return true;
}

bool SGPTrj::PredictA(const TimeJD& t, Vect6& f)
{
    if (!Predictor.Run(t))
        return false;

    PhasePoint6D pp;
    Predictor.GetDestPoint(pp);

    f = pp.CoordsVel;

    return true;
}

unsigned SGPTrj::Size() const
{
    return 6;
}
