#ifndef SITE_H
#define SITE_H 

#include <vector>
#include <map>
#include <myXML_Document.hpp>
#include "json_functions.h"
#include "DVectors.h"
#include "SiteId.h"

class Site
{
public:
    Vect3 GetCoordinates() const { return m_coordinates; };
    bool Load(myXML::Contain* parent);
    void load(const jsonval& parent);
    TSiteId GetId() const { return m_id; } //deprecated
    TSiteId getId() const { return m_id; }
    bool IsNeedAberrationCorrection() const { return m_needAberrationCorrection; }
    double GetSigmaAlpha() const { return m_sigmaAlpha; }
    double GetSigmaDelta() const { return m_sigmaDelta; }
    double get_lat_deg() const { return m_lat_deg; }
    double get_lon_deg() const { return m_lon_deg; }
    double get_alt_m() const { return m_alt_m; }
private:
    bool m_needAberrationCorrection;
    double m_sigmaAlpha;
    double m_sigmaDelta;
    Vect3 m_coordinates;
    TSiteId m_id;
    double m_lat_deg;
    double m_lon_deg;
    double m_alt_m;
};

typedef std::vector<Site> Sites;
typedef std::map<TSiteId, Site> SitesMap;

#endif
