#ifndef STALGORITHMS_H
#define STALGORITHMS_H

#include "Consts.h"

static double arc(double ss, double cc)
{
    double pi = Pi;
    double ret_val;
    static double a;
    a = atan2(ss, cc);
    if (a < 0.) {
        ret_val = a + pi * 2.;
    }
    else {
        ret_val = a;
    }
    return ret_val;
}

static int btpb(double* a, double* p, double* c__, const int* m, const int* n)
{
    int i__1, i__2, i__3, i__4;
    static int i__, j, k, l;
    static double s;
    static int ia, ja, ii, jj, kk, mm, nn;
    static double pp, ss;
    static int jaa;

    --c__;
    --p;
    --a;

    kk = 1;
    ia = 0;
    jaa = 0;
    ja = 0;
    nn = *m;
    i__1 = *n;
    for (l = 1; l <= i__1; ++l) {

        i__2 = *n;
        for (k = l; k <= i__2; ++k) {

            ss = 0.;
            i__3 = *m;
            for (j = 1; j <= i__3; ++j) {

                s = 0.;
                i__4 = *m;
                for (i__ = 1; i__ <= i__4; ++i__) {

                    if (j < i__) {
                        ii = j;
                        jj = i__;
                    }
                    else {
                        ii = i__;
                        jj = j;
                    }
                    mm = nn * (ii - 1) + jj - (ii - 1) * ii / 2;
                    pp = p[mm];
                    s += a[l + ia + jaa] * pp;
                    ia += *n;
                }

                ss += a[l + ja] * s;
                ja += *n;
                ia = 0;
            }

            c__[kk] = ss;
            ++kk;
            ++jaa;
            ja = 0;
        }

        jaa = 0;
    }

    return 0;
}

static void bpbt(const double* b, double* p, double* c, int m, int n)
{
    int i1, i2, i3, i4;
    int i, j, k, l;
    double s;
    int ia, ja, ii, jj, kk, mm, nn;
    double pp, ss;
    int jaa;
    --c;
    --p;
    --b;
    kk = 1;
    ia = 0;
    jaa = 0;
    ja = 0;
    nn = n;
    i1 = m;
    for (l = 1; l <= i1; ++l) {
        i2 = m;
        for (k = l; k <= i2; ++k) {
            ss = 0.;
            i3 = n;
            for (j = 1; j <= i3; ++j) {
                s = 0.;
                i4 = n;
                for (i = 1; i <= i4; ++i) {
                    if (j < i) {
                        ii = j;
                        jj = i;
                    }
                    else {
                        ii = i;
                        jj = j;
                    }
                    mm = nn * (ii - 1) + jj - (ii - 1) * ii / 2;
                    pp = p[mm];
                    s += b[i + ia] * pp;
                }
                ss += b[j + ja + jaa] * s;
            }
            ja += n;
            c[kk] = ss;
            ++kk;
        }
        ia += n;
        ja = 0;
        jaa += n;
    }
    return;
}

static void x2rnb(const double* x, double* a)
{
    double r, rr, rv[3];
    rr = sqrt(x[0] * x[0] + x[1] * x[1] + x[2] * x[2]);
    a[0] = x[0] / rr;
    a[1] = x[1] / rr;
    a[2] = x[2] / rr;
    rv[0] = x[1] * x[5] - x[2] * x[4];
    rv[1] = x[2] * x[3] - x[0] * x[5];
    rv[2] = x[0] * x[4] - x[1] * x[3];
    r = sqrt(rv[0] * rv[0] + rv[1] * rv[1] + rv[2] * rv[2]);
    a[6] = rv[0] / r;
    a[7] = rv[1] / r;
    a[8] = rv[2] / r;
    a[3] = (a[1] * a[8] - a[2] * a[7]);
    a[4] = (a[2] * a[6] - a[0] * a[8]);
    a[5] = (a[0] * a[7] - a[1] * a[6]);
}

static void kx2krnb(double* x, double* akx, double* akrnb)
{
    double a33[9];
    double a66[36];
    int i, j, i3, i6;

    x2rnb(x, a33);

    for (i = 0; i <= 2; ++i) {
        i6 = i * 6;
        i3 = i * 3;
        for (j = 0; j <= 2; ++j) {
            a66[i6 + j] = a33[i3 + j];
            a66[i6 + j + 3] = 0.;
        }
    }

    for (i = 3; i <= 5; ++i) {
        i6 = i * 6;
        i3 = (i - 3) * 3;
        for (j = 0; j <= 2; ++j) {
            a66[i6 + j] = 0.;
            a66[i6 + j + 3] = a33[i3 + j];
        }
    }

    bpbt(a66, akx, akrnb, 6, 6);
}

static bool b701(const double* bq, double t, double* rez)
{
    double d1;
    double a, c;
    double s, u1, u2, en, rc, hn, rs, en1, hn1, rcu, rsu;
    int i, j, k;
    int count = 0;

    //
    //    double exp(), cos(), sqrt(), sin();
    //
    //    /* Local variables */
    //
    ///* ---------------------------------------------------------- */
    ///* 1.  вычисление кинематических параметров движения спут- */
    ///*     ника в текущий момент времени  t */
    //
    ///* 2.  CALL B701(BQ,T,REZ) */
    ///* 3.  BQ(41)  - выход подпрограммы b700 */
    ///*     T       - */
    ///*     REZ(10) - выход подпрограммы b701 */
    ///* 3a  BQ,T */
    ///* 3b  REZ */
    ///* ---------------------------------------------------------- */
    //    --rez;
    //    --bq;
    rez[0] = t;
    //    primat2(1,1,&bq[18]);
    d1 = bq[18] - 1.;

    if (d1 < 0.) {
        goto L1;
    }
    else if (fabs(d1) < 1.e-99) {
        goto L2;
    }
    else {
        goto L3;
    }

L2:


L3:
    // ######################
    //    exit (0);
    // ######################

    a = bq[17] * (t - bq[21]);
    hn1 = 2.;
L8:
    hn = hn1;
    hn1 = hn - ((a + hn) * 2. * exp(-hn) - bq[18] * (1. - exp(hn * -2.))) /
        (exp(-hn) * 2. - bq[18] * (exp(hn * -2.) + 1.));
    if (fabs(hn1 - hn) >= 1e-12) {
        goto L8;
    }
    rc = bq[35] * (bq[18] - 1. / cos(hn1));
    rs = bq[35] * sqrt(bq[18] * bq[18] - 1.) / sin(hn1);
    for (i = 2; i <= 4; ++i) {
        j = i + 6;
        k = i + 9;
        rez[i] = rc * bq[j] + rs * bq[k];
    }
    rez[7] = sqrt(rez[1] * rez[1] + rez[2] * rez[2] + rez[3] * rez[3]);
    rcu = -bq[17] * bq[35] * bq[35] / sin(hn1) / rez[7];
    rsu = bq[17] * bq[35] * bq[35] * sqrt(bq[18] * bq[18] - 1.) / cos(hn1) / rez[7];
    goto L10;
L1:
    // ######################
    //    exit (0);
    // ######################

    a = bq[17] * (t - bq[40]);
    en1 = a + bq[33] + bq[32] * sin(a) - bq[33] * cos(a);
L4:
    en = en1;
    //	en1=en-(en-a-bq[33]+bq[33]*cos(en)-bq[32]*sin(en))/(1.-bq[33]*sin(en)- bq[33] * cos(en));
    //	en1=en-(en-a+bq[33]+bq[33]*cos(en)-bq[32]*sin(en))/(1.-bq[33]*sin(en)- bq[32] * cos(en));
    en1 = en - (en - a - bq[33] + bq[33] * cos(en) - bq[32] * sin(en)) / (1. - bq[33] * sin(en) - bq[32] * cos(en));
    if (fabs(en1 - en) >= 1e-11) {
        if (count++ > 1000) {
            return false;
        }
        goto L4;
    }
    s = sin(en1);
    c = cos(en1);
    u1 = bq[36] * c + bq[27] * s;
    u2 = bq[36] * s - bq[27] * c;
    rc = bq[35] * (c - bq[28] * u1 - bq[37]);
    rs = bq[35] * (u1 - bq[36]);
    for (i = 2; i <= 4; ++i) {
        j = i + 6;
        k = i + 9;
        rez[i - 1] = rc * bq[j - 1] + rs * bq[k - 1];
    }
    rez[7] = sqrt(rez[1] * rez[1] + rez[2] * rez[2] + rez[3] * rez[3]);
    rez[8] = rs / rez[7];
    rez[9] = rc / rez[7];
    rcu = bq[26] * (bq[28] * u2 - s) / rez[7];
    rsu = -bq[26] * u2 / rez[7];
L10:
    for (i = 5; i <= 7; ++i) {
        j = i + 3;
        k = i + 6;
        rez[i - 1] = rcu * bq[j - 1] + rsu * bq[k - 1];
    }
    return true;
}

static int b707(const double* bk, double* bq, double* rez)
{
    int i, j, k, l, m, n;
    double r1, r2, s1, s2, t1, t2, en[3], er[3], vh, vr;
    for (i = 1; i <= 3; ++i) {
        j = i + 1;
        er[i - 1] = bk[j - 1] / bk[7];
    }
    ///
    en[0] = bq[14] * er[2] - bq[15] * er[1];
    en[1] = bq[15] * er[0] - bq[13] * er[2];
    en[2] = bq[13] * er[1] - bq[14] * er[0];
    vr = er[0] * bk[4] + er[1] * bk[5] + er[2] * bk[6];
    vh = sqrt(bq[34] * bq[19]) / bk[7];
    r1 = bq[28] * 2. * bk[9] + bq[29] * bk[8];
    r2 = bq[30] * bk[8] + bq[31] * bk[9];
    s1 = bq[28] * 2. * bk[8] - bq[29] * bk[9];
    s2 = bq[30] * bk[9] - bq[31] * bk[8];
    t1 = s1 + (bq[37] + 2.) * bq[29];
    t2 = s2 - (bq[37] + 2.) * bq[30];
    k = 1;
    l = 6;
    m = 19;
    n = 24;
    for (i = 2; i <= 4; ++i) {
        j = i + 3;
        rez[l - 1] = -bk[j - 1];
        rez[n - 1] = bq[34] * bk[i - 1] / bk[7] / bk[7] / bk[7];
        rez[m - 1] = ((bk[0] - bq[40]) * 3. * bq[34] * bk[i - 1] / bk[7] / bk[7] /
            bk[7] - bk[j - 1]) * .5 / bq[35];
        rez[k - 1] = (bk[i - 1] - (bk[0] - bq[40]) * 1.5 * bk[j - 1]) / bq[35];
        k += 6;
        l += 6;
        m += 6;
        n += 6;
    }
    j = 2;
    k = 3;
    l = 4;
    m = 22;
    for (i = 1; i <= 3; ++i) {
        n = i + 13;
        rez[j - 1] = -bq[35] * (r1 * er[i - 1] - (bk[7] * t1 / bq[19] + s1) * en[i - 1]);
        rez[k - 1] = -bq[35] * (r2 * er[i - 1] + (bk[7] * t2 / bq[19] + s2) * en[i - 1]);
        rez[m - 1] = bk[6] * bq[n - 1] / sin(bq[38]);
        rez[l - 1] = bk[3] * bq[n - 1] / sin(bq[38]);
        l += 6;
        k += 6;
        m += 6;
        j += 6;
    }
    rez[4] = -bk[2];
    rez[10] = bk[1];
    rez[16] = 0.;
    j = 20;
    k = 21;
    for (i = 1; i <= 3; ++i) {
        rez[j - 1] = bq[35] * (vh * r1 * en[i - 1] - (vh * er[i - 1] - vr * en[i - 1]) * t1) / bq[19];
        rez[k - 1] = bq[35] * (vh * r2 * en[i - 1] + (vh * er[i - 1] - vr * en[i - 1]) * t2) / bq[19];
        j += 6;
        k += 6;
    }
    rez[22] = -bk[5];
    rez[28] = bk[4];
    rez[34] = 0.;
    return 0;
}

static int b700(double rmu, double* q, double* rez)
{
    double a, c, d, e, g, h;
    int i, j, k;
    double p, s, ho, cw, sw;

    rez[34] = rmu;
    for (i = 1; i <= 6; ++i) {
        j = i + 35;
        rez[j - 1] = q[i - 1];
    }
    rez[26] = sqrt(rmu * q[0]);
    rez[17] = rez[26] / q[0] / q[0];
    e = q[1] * q[1] + q[2] * q[2];
    rez[18] = sqrt(e);
    rez[19] = q[0] * (1. - e);
    c = q[2] + 1.;
    rez[27] = sqrt(1. - e);
    rez[20] = sqrt(rmu * rez[19]);
    rez[16] = 6.28318530717959 / rez[17];
    rez[6] = rez[19] / c;
    rez[28] = q[1] / c;
    rez[29] = (1. - q[2]) / c;
    rez[30] = q[2] * rez[28] / c;
    rez[31] = 1. - rez[28] * rez[28];
    rez[32] = q[1] * rez[28] + q[2];
    rez[33] = rez[28] * rez[27];
    rez[7] = cos(q[4]);
    rez[8] = sin(q[4]);
    rez[9] = 0.;
    rez[12] = sin(q[3]);
    rez[15] = cos(q[3]);
    rez[10] = -rez[15] * rez[8];
    rez[11] = rez[15] * rez[7];
    rez[13] = rez[12] * rez[8];
    rez[14] = -rez[12] * rez[7];
    for (j = 1; j <= 3; ++j) {
        i = j + 7;
        rez[j - 1] = rez[6] * rez[i - 1];
    }
    for (k = 4; k <= 6; ++k) {
        i = k + 4;
        j = k + 7;
        rez[k - 1] = rmu * (c * rez[j - 1] - q[1] * rez[i - 1]) / rez[20];
    }
    rez[24] = q[0] * (rez[18] + 1.);
    rez[22] = q[0] * fabs(1. - rez[18]);
    if (rez[18] > .001) {
        goto L3;
    }
    rez[25] = 0.;
    rez[21] = q[5];
    goto L4;
L5:
    rez[31] = sqrt((rez[18] - 1.) / (rez[18] + 1.));
    rez[33] = q[2] / rez[18];
    rez[15] = q[1] / rez[18];
    a = sin(rez[25] * -.5) / cos(rez[25] * -.5);
    ho = log((rez[32] * a + 1.) / (1. - rez[32] * a));
    rez[24] = ho;
    rez[21] = q[5] - rez[18] / sin(ho) / rez[17];
L3:
    cw = q[2] / rez[18];
    sw = q[1] / rez[18];
    if (fabs(sw) > 1.) {
        if (q[1] > 0.) { sw = 1.; }
        if (q[1] < 0.) { sw = -1.; }
        if (fabs(q[1]) < 1.e-99) { sw = 0.; }
    }
    rez[25] = arc(sw, cw);
    if (rez[18] > 1.) { goto L5; }
    h = -(rmu) / q[0];
    d = rez[22] * (sw - rez[28] * (cw - 1.));
    s = sqrt((fabs(h))) * d / rez[20];
    g = rmu * (q[1] * d + rez[22] * (cw + q[2])) / rez[20] / rez[20];
    if (fabs(s) > 1.) {
        if (d > 0.) { s = 1.; }
        if (d < 0.) { s = -1.; }
        //       if(d = 0.) { s=0.; }
        if (fabs(d) < 1.e-99) { s = 0.; }
    }
    p = arc(s, g);
    rez[21] = q[5] - rmu * (rez[32] * s + rez[33] * (1. - g) - p) / sqrt(fabs(h * h * h));
L4:
    rez[23] = rez[21] + rez[16] * .5;
    return 0;
} /* b700_ */

static void b423(double rmu, double t, const double* xyz, double* rez)
{
    double a, b, f, g, p, s, r, v, x, y, z, cc, c, cx, cy, cz, fx, fy, fz, vx, vy, vz, cxy;
    double abs17, h, d, d1, d2;

    x = xyz[0];
    y = xyz[1];
    z = xyz[2];
    vx = xyz[3];
    vy = xyz[4];
    vz = xyz[5];
    rez[0] = t;
    r = sqrt(x * x + y * y + z * z);
    v = vx * vx + vy * vy + vz * vz;
    cx = y * vz - z * vy;
    cy = z * vx - x * vz;
    cz = x * vy - y * vx;
    cxy = cx * cx + cy * cy;
    c = sqrt(cxy + cz * cz);
    rez[8] = c;
    rez[9] = cx;
    rez[10] = cy;
    rez[11] = cz;
    cxy = sqrt(cxy);
    cc = rmu / r;
    fx = cz * vy - cy * vz - cc * x;
    fy = cx * vz - cz * vx - cc * y;
    fz = cy * vx - cx * vy - cc * z;
    f = sqrt(fx * fx + fy * fy + fz * fz);
    rez[12] = f;
    rez[13] = fx;
    rez[14] = fy;
    rez[15] = fz;
    rez[16] = cxy / cz;
    rez[7] = v - cc * 2.;

    rez[4] = atan(cxy / cz);
    if (cz < 0.) {
        rez[4] = atan(cxy / cz) + 3.14159265358979323846;
    }
    if (cz == 0.) {
        rez[4] = 1.570796326794896619231;
    }
    rez[17] = cx / cxy;
    abs17 = fabs(rez[17]);
    if (abs17 < 1.e-20) { abs17 = 1.e-20; }
    if (abs17 > 1.) {
        rez[17] = cx * rez[17] / abs17;
    }

    rez[18] = -cy / cxy;
    rez[5] = arc(rez[17], rez[18]);
    rez[1] = -rmu / rez[7];
    rez[2] = c * fz / rmu / cxy;
    rez[3] = (cx * fy - cy * fx) / rmu / cxy;
    rez[19] = c * z / r / cxy;
    rez[20] = (cx * y - cy * x) / r / cxy;

    a = rez[2] * rez[2] / (rez[3] + 1.) + rez[3];
    d1 = fabs(1. - rez[2] * rez[2] - rez[3] * rez[3]);
    d2 = sqrt(d1);

    b = d2 * rez[2] / (rez[3] + 1.);
    d = r * (rez[19] - rez[2] * (rez[20] - 1.) / (rez[3] + 1.));
    s = sqrt((fabs(rez[7]))) * d / c;
    g = rmu * (rez[2] * d + r * (rez[20] + rez[3])) / c / c;

    p = 0;

    if (rez[7] > 0.) { h = 1.; }
    if (rez[7] < 0.) { h = -1.; }
    if (rez[7] == 0.) { h = 0.; }
    rez[6] = 0.;
    if (rez[7] < 0.) { p = arc(s, g); }
    goto L2;
    //    if(rez[7] > 0.) { p=log(s+g);}
L2:
    rez[6] = t + h * rmu * (p - b * (1. - g) - a * s) / (sqrt((fabs(rez[7]))) * fabs(rez[7]));

    if (rez[7] < 0.) {
        rez[21] = rez[1] * 6.2831853071795862 * sqrt(rez[1]) / sqrt(rmu);
    }
    //    return 0;
} /* b423_ */


static void gauss(double* a, double* b, double* x, int n)
{
    int i, j, k, l, m;
    int n1;
    double r1, r2, r3;
    double s;
    if (n == 1) {
        x[0] = b[0] / a[0];
        return;
    }
    n1 = n - 1;
    k = 1;
L10:
    i = k + 1;
    l = k;
L20:
    r1 = fabs(a[i + (k - 1) * n - 1]);
    r2 = fabs(a[l + (k - 1) * n - 1]);

    if (r1 - r2 >= 0.) {
        goto L21;
    }
    else {
        goto L30;
    }
L21:
    l = i;
L30:
    if (i == n) {
        goto L40;
    }
    ++i;
    goto L20;
L40:
    if (l == k) {
        goto L60;
    }
    j = k;
    for (j = k; j <= n; ++j) {
        r3 = a[k + (j - 1) * n - 1];
        a[k + (j - 1) * n - 1] = a[l + (j - 1) * n - 1];
        a[l + (j - 1) * n - 1] = r3;
        r3 = b[k - 1];
    }
    b[k - 1] = b[l - 1];
    b[l - 1] = r3;

L60:
    i = k + 1;
    l = i;
    for (i = l; i <= n; ++i) {
        r3 = a[i + (k - 1) * n - 1] / a[k + (k - 1) * n - 1];
        a[i + (k - 1) * n - 1] = 0.;
        j = k + 1;
        m = k + 1;
        for (j = m; j <= n; ++j) {
            a[i + (j - 1) * n - 1] = a[i + (j - 1) * n - 1] - r3 * a[k + (j - 1) * n - 1];
        }
        b[i - 1] = b[i - 1] - r3 * b[k - 1];
    }
    if (k == n1) {
        goto L90;
    }
    ++k;

    goto L10;
L90:
    x[n - 1] = b[n - 1] / a[n + (n - 1) * n - 1];
    i = n - 1;

L93:
    j = i + 1;
    s = 0.;
    k = j;
    for (j = k; j <= n; ++j) {
        s = s - a[i + (j - 1) * n - 1] * x[j - 1];
    }
    x[i - 1] = (b[i - 1] + s) / a[i + (i - 1) * n - 1];
    if (i == 1) {
        goto L92;
    }
    --i;
    goto L93;
L92:
    return;
} /* gauss_ */

static void obgau(int n, const double* a, double* rab, double* obm)
{
    int i, j, k;
    int nn;
    nn = n * n;
    for (j = 1; j <= n; ++j) {
        for (i = 1; i <= n; ++i) {
            rab[i - 1] = 0.;
        }
        rab[j - 1] = 1.;
        for (k = 1; k <= nn; ++k) {
            rab[n + k - 1] = a[k - 1];
        }
        gauss(&rab[n], rab, &obm[(j - 1) * n], n);
    }
}

#endif
