#ifndef TLEDATA_H
#define TLEDATA_H 

#include <myXML_Document.hpp>
#include "TM.h"
#include "msgp.h"

class TleData
{
public:
    TleData()
    {
    };

    virtual ~TleData()
    {
    };
    void Init(const TleData& data);
    bool Load(myXML::Contain* parent);

    double GetNDot() const { return m_ndot; }
    double GetNDDot() const { return m_nddot; }
    double GetBStar() const { return m_bstar; }
    double GetInclination() const { return m_inclination; }
    double GetRAAN() const { return m_raan; }
    double GetEccentricity() const { return m_eccentricity; }
    double GetArgOfPerigee() const { return m_argofperigee; }
    double GetMeanAnomaly() const { return m_meananomaly; }
    double GetMeanMotion() const { return m_meanmotion; }
    int GetSolution() const { return m_solution; }
    int GetRev() const { return m_rev; }

    TLESet CreateTleSet(const TimeJD& date) const;
protected:

    double m_ndot;
    double m_nddot;
    double m_bstar;
    double m_inclination;
    double m_raan;
    double m_eccentricity;
    double m_argofperigee;
    double m_meananomaly;
    double m_meanmotion;
    int m_rev;
    int m_solution;
};

#endif
