#include "XMLFunctions.h"

void GetChildren(myXML::Contain* parent, std::map<std::string, myXML::Contain*>& items)
{
    myXML::ChildIter it = parent->BeginChildIter();
    while (it != parent->EndChildIter()) {
        if ((*it)->GetType() == myXML::Document::Container) {
            items[(*it)->Get()] = (myXML::Contain*)(*it);
        }
        ++it;
    }
}

void GetChildren(const std::map<std::string, myXML::Contain*>& parent, std::map<std::string, myXML::Contain*>& items)
{
    for (const auto& it : parent) {
        items[it.first] = it.second;
    }
}

void GenerateEmergeXML(const std::string& msg, const std::string& outputfile)
{
    std::stringstream outs;
    outs << "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
    outs << "<Root>";
    outs << "<Error>";
    outs << msg;
    outs << "</Error>";
    outs << "</Root>";

    if (outputfile.length() != 0) {
        WriteFile(outputfile, outs.str());
    }
    else {
        std::cout << outs.str() << "\n";
    }
}

bool FindFirstContainer(myXML::Contain* parent, const std::string& name, myXML::Contain*& ret)
{
    myXML::ChildIter it = parent->BeginChildIter();
    while (it != parent->EndChildIter()) {
        if ((*it)->GetType() == myXML::Document::Container && (*it)->Get() == name) {
            ret = (myXML::Contain*)*it;
            return true;
        }
        ++it;
    }
    return false;
}

bool FindXMLContainer(myXML::Contain* parent, const std::string& name, myXML::Contain*& result)
{
    return FindFirstContainer(parent, name, result);
}

bool FindXMLContainer(const std::map<std::string, myXML::Contain*>& items, const std::string& name, myXML::Contain*& result)
{
    return GetMapItem(items, name, result);
}
