#ifndef XYZ_H
#define XYZ_H 

class XYZ
{
public:
    double x, y, z;

    XYZ();
    XYZ(const XYZ& right);
    XYZ(double px, double py, double pz);
    virtual ~XYZ();

    XYZ operator +(const XYZ& right) const;
    XYZ operator -(const XYZ& right) const;
    XYZ operator *(double c) const;
    XYZ operator /(double c) const;
    bool operator ==(const XYZ& right) const;
    bool operator !=(const XYZ& right) const;
    XYZ& operator =(const XYZ& right);
    XYZ cross(const XYZ& right) const;

    double Magnitude() const;
    double MagnitudeSquared() const;
    void Normalize();
};


#endif
