#pragma once

#include "TM.h"
#include "DVectors.h"
#include "PhasePoint.h"

class GFCSRotator
{
public:
    GFCSRotator()
    {
    };
    GFCSRotator(const TimeJD& baseDate);
    void Init(const TimeJD& baseDate);
    void Rotate(const TimeJD& date, TransMtx& CJ2000toGFCS, TransMtx& CGFCStoJ2000) const;
    void J2000ToGCS(const PhasePoint6D& j2000, PhasePoint6D& gcs) const;
    void J2000ToGCS(const TimeJD& date, const Vect6& j2000, Vect6& gcs) const;
    void J2000ToLocalJ2000(const TimeJD& date, const Vect6& j2000, const Vect3& siteGcsPos, Vect6& localJ2000) const;
    void J2000ToNze(const TimeJD& date, const Vect6& j2000, const Vect3& siteGcsPos, Vect6& nze) const;
    void GCSToJ2000(const PhasePoint6D& gcs, PhasePoint6D& j2000) const;
    void GCSToJ2000(const TimeJD& date, const Vect6& gcs, Vect6& j2000) const;
private:
    void GetGcsToJ20006dConverter(const TimeJD& date, FrameConverter6D& gcsToJ2000) const;
    void GetJ2000ToGcs6dConverter(const TimeJD& date, FrameConverter6D& j2000ToGcs) const;
    void GetJ2000ToNze6dConverter(const TimeJD& date, const Vect3& siteGcsPos, FrameConverter6D& J2000toNze) const;
    void GetJ2000ToLocalJ20006dConverter(const TimeJD& date, const Vect3& siteGcsPos, FrameConverter6D& J2000toLocalJ2000) const;
    TransMtx BJ2000toGFCS;
    TimeJD m_baseDate;
};
