#pragma once

#include "json_functions.h"
#include <myXML_Document.hpp>

class IntegratorCfg
{
public:
    IntegratorCfg()
    {
    }

    IntegratorCfg(double eps, double stepinit, double stepmin, bool precItrf) :
        m_eps(eps), m_stepinit(stepinit), m_stepmin(stepmin), m_precItrf(precItrf)
    {
    }

    void load(const jsonval& parent);
    bool Load(myXML::Contain* parent);
    double getEps() const { return m_eps; }
    double getStepInit() const { return m_stepinit; }
    double getStepMin() const { return m_stepmin; }
    bool getPrecItfr() const { return m_precItrf; }
private:
    double m_eps{1E-9};
    double m_stepinit{10E-3};
    double m_stepmin{.1E-3};
    bool m_precItrf{false};
};
