#pragma once

#include "DVectors.h"
#include "TM.h"
#include <string>
#include "json_functions.h"

class IRes
{
public:
    IRes();
    IRes(const Vect6& vec, const TimeJD& date, double age, std::string orbitid, bool addon = false);
    IRes(const Vect6& vec, const Vect3& rnb, const TimeJD& date, double age, std::string orbitid, bool addon = false);
    void load(const jsonval& parent);
    TimeJD get_date() const { return m_date; }
    const Vect6& get_pos() const { return m_vec; }
    const Vect3& get_rnb() const { return m_rnb; }
    bool is_addon() const { return m_addon; }
    double get_age() const { return m_age; }
    bool has_rnb() const { return m_has_rnb; }
private:
    std::string m_orbitid;
    Vect6 m_vec;
    Vect3 m_rnb;
    TimeJD m_date;
    double m_age;
    bool m_addon;
    bool m_has_rnb{false};
};
