#pragma once

#include "TM.h"
#include "json_functions.h"
#include "ires.h"

class orb_block_data {
public:
    orb_block_data() = default;
    orb_block_data(
        std::string orbitid,
        const TimeJD& date,
        const TimeJD& beg,
        const TimeJD& end);
    orb_block_data(
        std::string orbitid,
        const TimeJD& date,
        const TimeJD& beg,
        const TimeJD& end,
        double mind,
        std::string next_orbitid);

    orb_block_data(
        std::string orbitid,
        const TimeJD& date,
        const TimeJD& beg,
        const TimeJD& end,
        double mind,
        std::string next_orbitid,
        const std::vector<IRes>& vecs
    );
    void load(const jsonval& parent);
    TimeJD get_date() const { return m_date; }
    TimeJD get_beg() const { return m_beg; }
    TimeJD get_end() const { return m_end; }
    const std::string& get_orbitid() const { return m_orbitid; }
    const std::string& get_next_orbitid() const { return m_next_orbitid; }
    double get_min_distance() const { return m_mind; }
    const std::vector<IRes>& get_vecs() const { return m_vecs; }
private:
    std::string m_orbitid;
    std::string m_next_orbitid;
    TimeJD m_date;
    TimeJD m_beg;
    TimeJD m_end;
    double m_mind;
    std::vector<IRes> m_vecs;
};
