#pragma once

#include "TM.h"
#include <vector>
#include "ires.h"
#include "StateVector.h"

std::vector<TimeJD> generate_dates(const TimeJD& sdate, const TimeJD& edate, double step_sec);
std::vector<IRes> calc_positions_on_dates(const SInitOrbit& orbit, const TimeJD& beg, const TimeJD& end, double step_sec);
std::vector<IRes> calc_positions_on_dates(const SInitOrbit& orbit, const std::vector<TimeJD>& dates);
std::vector<SInitOrbit> calc_orbits_on_dates(const SInitOrbit& orbit, const std::vector<TimeJD>& dates, bool variates);
std::vector<SInitOrbit> calc_orbits_on_dates(const SInitOrbit& orbit, const TimeJD& beg, const TimeJD& end, double step_sec, bool variates);
double calc_age(const SInitOrbit& orbit, const TimeJD& date);
