#include "trj_inter.h"

TrjInter::TrjInter(const OrbBlocksStore& orbit_processor)
    : m_orbit_processor(orbit_processor)
{
}

bool TrjInter::Predict(const TimeJD& t, const IFrame& fr, Vect6& f)
{
    Vect6 p = m_orbit_processor.get_pos(t);

    p.x /= 1E6;
    p.y /= 1E6;
    p.z /= 1E6;
    p.vx /= 1E3;
    p.vy /= 1E3;
    p.vz /= 1E3;

    PhasePoint6D pp(J2000Frame(), p, t);
    pp.Convert(fr);
    f = pp.CoordsVel;

    return true;
}

bool TrjInter::PredictMatrix(const TimeJD& t, const IFrame& fr, Vect6& f, DMatrix& m)
{
    return true;
}

bool TrjInter::Move(const TimeJD& t, DVector& u)
{
    return true;
}

bool TrjInter::Init(const DVector& u0)
{
    return true;
}
