#pragma once

#include "ITraject.h"
#include "interpolate.h"

class TrjInterX : public ITraject {
public:
    TrjInterX(const XInterpolator& itp);
    virtual bool Predict(const TimeJD& t, const IFrame& fr, Vect6& f);
    virtual bool PredictMatrix(const TimeJD& t, const IFrame& fr, Vect6& f, DMatrix& m);
    virtual bool Move(const TimeJD& t, DVector& u);
    virtual unsigned Size() const { return 6; }
    virtual bool Init(const DVector& u0);

    virtual void SetTime(const TimeJD& t)
    {
    }
    virtual const TimeJD& GetTime() const { return dummy; }
    virtual IPredict* GetPredictor() { return nullptr; }
private:
    const XInterpolator& m_itp;
    TimeJD dummy;
};
