/*
 * Copyright 2010 Boris Popov <popov.b@gmail.com>
 */

#include "probing.hpp"
#include <myXML_Document.hpp>

//-----------------------------------------------
dxml::Prober::Prober () {

	return;
}

dxml::Prober::~Prober () {

	return;
}

bool dxml::Prober::Probing (XmlSContainer& xsc) {

	bool Success = true;
	bool Fault = false;

	m_Init ();

	XmlString* xml = xsc.Pop ();
	while (xml != NULL) {

		if ( m_IsItValid (*xml) )  m_Local.Add (*xml);
		xml = xsc.Pop ();
	}

	if ( m_Local.GetSize () == 0 )  return Fault;

	xsc = m_Local;
	return Success;
}
		
void dxml::Prober::m_Init () {

	m_Local.Release ();
	return;
}
		
bool dxml::Prober::m_IsItValid
(const XmlString& xml) const {

	myXML::Document Doc;
	if ( Doc.LoadStringX ( xml.c_str () ) ) return true;
	return false;
}
//-----------------------------------------------
