/*
 * Copyright 2010 Boris Popov <popov.b@gmail.com>
 */

#include "bytebuffer.hpp"

//-----------------------------------------------
common::ByteBuffer::ByteBuffer
(const size_t size):
m_Size (size),
m_Pos (0),
m_LastBuffer (NULL) {

	return;
}

common::ByteBuffer::~ByteBuffer () {

	m_KillBuffersCont ();
	return;
}
		
void common::ByteBuffer::m_KillBuffersCont () {

	if ( m_BuffersCont.GetSize () == 0 ) return;

	byte_t* byte = NULL;
	byte = m_BuffersCont.Pop ();
	while (byte != NULL) {

		delete [] byte;
		byte = m_BuffersCont.Pop ();
	}

	return;
}

common::ByteBuffer&
common::ByteBuffer::operator<< (const byte_t byte) {

	if (! m_IsLastBufferExist () ) {

		m_MakeBuffer ();
	}

	if (m_Pos == m_Size) {

		m_MakeBuffer ();
	}

	m_AddByteLastBuffer (m_Pos, byte);

	++m_Pos;	

	return *this;
}

common::String common::ByteBuffer::Get () {

	size_t countbuf = m_BuffersCont.GetSize ();

	if (countbuf == 0 ) return "";

	byte_t* tempb = new byte_t [countbuf * m_Size];
	m_FillAnyBuffer (tempb, countbuf * m_Size);
	
	m_MoveToNewBuffer (tempb);

	String temp (tempb);
	delete [] tempb;
	m_Pos = 0;
	m_LastBuffer = NULL;
	return temp;
}
		
void common::ByteBuffer::m_MoveToNewBuffer
(byte_t* newbuff) {

	size_t grand = 0;

	byte_t* byte = m_BuffersCont.Pop ();
	while (byte != NULL) {

		for (size_t i = 0; i < m_Size; i++) {

			m_AddByteAnyBuffer
				(newbuff, grand, *(byte + i));
			++grand;
		}
		delete [] byte;
		byte = m_BuffersCont.Pop ();
	}
	return;
}
		
bool common::ByteBuffer::m_IsLastBufferExist () const {

	if (m_LastBuffer == NULL) return false;
	return true;
}
		
void common::ByteBuffer::m_MakeBuffer () {

	m_LastBuffer = new byte_t [m_Size];
	m_FillLastBuffer ();
	m_Pos = 0;
	m_BuffersCont.Add (*m_LastBuffer);
	return;
}
		
void common::ByteBuffer::m_FillLastBuffer () {

	m_FillAnyBuffer (m_LastBuffer, m_Size);
	return;
}
		
void common::ByteBuffer::m_AddByteLastBuffer
(size_t shift, byte_t byte) {

	m_AddByteAnyBuffer (m_LastBuffer, shift, byte);
	return;
}
		
void common::ByteBuffer::m_AddByteAnyBuffer
(byte_t* buffer, size_t shift, byte_t byte) {

	*(buffer + shift) = byte;
	return;
}
		
void common::ByteBuffer::m_FillAnyBuffer
(byte_t* buffer, size_t size) {
	
	for (size_t i = 0; i < size; i++) {

		m_AddByteAnyBuffer (buffer, i, '\0');
	}
	return;
}
//-----------------------------------------------
