/*
 * Copyright 2010 Boris Popov <popov.b@gmail.com>
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <cstdlib>
#include <mystring.hpp>
#include <qcontainer.hpp>

#ifndef __bytebuffer__hpp__
#define __bytebuffer__hpp__

namespace common {

//-----------------------------------------------
typedef char byte_t;
typedef QContainer <byte_t> BuffersCont;
typedef size_t Position;
//-----------------------------------------------

//-----------------------------------------------
class ByteBuffer {

	public:
		ByteBuffer (const size_t);
		~ByteBuffer ();

		ByteBuffer& operator<< (const byte_t);
		String Get ();

	private:
		ByteBuffer (const ByteBuffer&);
		ByteBuffer& operator= (const ByteBuffer&);

		const size_t m_Size;
		Position m_Pos;

		BuffersCont m_BuffersCont;
		void m_KillBuffersCont ();

		byte_t* m_LastBuffer;
		bool m_IsLastBufferExist () const;
		
		void m_MakeBuffer ();
		void m_FillLastBuffer ();
		void m_AddByteLastBuffer (size_t, byte_t);
		
		void m_AddByteAnyBuffer (byte_t*, size_t, byte_t);
		void m_FillAnyBuffer (byte_t*, size_t);

		void m_MoveToNewBuffer (byte_t*);
};
//-----------------------------------------------
}
#endif /* __bytebuffer__hpp__ */
