/*
 * Copyright 2010 Boris Popov <popov.b@gmail.com>
 */

#include "mystring.hpp"

//-----------------------------------------------
namespace common {

static bool _IsItDelimiter (const char ch);

}
//-----------------------------------------------

//-----------------------------------------------
static bool common::_IsItDelimiter (const char ch) {
	
	bool DELIMITER = true;
	bool NO_DELIMITER = false;
	
	switch (ch) {
		
		case ' ':  return DELIMITER;
		case '\n': return DELIMITER;
		case '\t': return DELIMITER;
		case '\f': return DELIMITER;
		case '\r': return DELIMITER;
		default: return NO_DELIMITER;
	}
}
//-----------------------------------------------

//-----------------------------------------------
common::String common::RemoveDelimiter
(const String& what) {

	/* удалить разделители
	 * в начале и конце what
	 */

	String temp;
	size_t pos = 0;
	size_t start = 0;
	size_t end = what.size () - 1;
	const char* my_string = what.c_str ();

	while (_IsItDelimiter (my_string [pos]))  pos++;
	start = pos;//начало без разделителей

	pos = end;
	while (_IsItDelimiter (my_string [pos])) pos--;
	
	end = pos;//конец без разделителей
	temp.assign (what, start, end - start + 1);
	return temp;
}
//-----------------------------------------------
