/*
 * Copyright 2010 Boris Popov <popov.b@gmail.com>
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <queue>

#ifndef __qcontainer__hpp__
#define __qcontainer__hpp__

namespace common {

//-----------------------------------------------
template <class X> class QContainer {

	public:
		QContainer ();
		~QContainer ();
		
		QContainer (const QContainer&);
		QContainer& operator= (const QContainer&);
		
		void Add (X&);
		X* Pop ();

		size_t GetSize () const;
		
		void Release ();

	private:
		std::queue <X*> m_Queue;
};
//-----------------------------------------------
}

//-----------------------------------------------
template <class X>
common::QContainer<X>::QContainer (const QContainer& qc):
m_Queue (qc.m_Queue) {

	return;
}

template <class X>
common::QContainer<X>& 
common::QContainer<X>::operator= (const QContainer& qc) {

	m_Queue = qc.m_Queue;
	return *this;
}

template <class X>
common::QContainer<X>::QContainer () {

	return;
}

template <class X>
common::QContainer<X>::~QContainer () {

	return;
}

template <class X>
void common::QContainer<X>::Add (X& x) {
	
	m_Queue.push (&x);
	return;
}

template <class X>
X* common::QContainer<X>::Pop () {

	if (m_Queue.empty ()) return NULL;
	X* cmd = m_Queue.front ();
	m_Queue.pop ();
	return cmd;
}
		
template <class X>
size_t common::QContainer<X>::GetSize () const {

	return m_Queue.size ();
}

template <class X>
void common::QContainer<X>::Release () {

	while ( Pop () != NULL ) ;
	return;
}
//-----------------------------------------------
#endif /* __qcontainer__hpp__ */
