/*
 * Copyright 2010 Boris Popov <popov.b@gmail.com>
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stack>

#ifndef __scontainer__hpp__
#define __scontainer__hpp__

namespace common {

//-----------------------------------------------
template <class X> class SContainer {

	public:
		SContainer ();
		~SContainer ();
		
		SContainer (const SContainer&);
		SContainer& operator= (const SContainer&);
		
		void Add (X&);
		X* Pop ();

		size_t GetSize () const;

		void Release ();

	private:
		std::stack <X*> m_Stack;
};
//-----------------------------------------------
}

//-----------------------------------------------
template <class X>
common::SContainer<X>::SContainer (const SContainer& sc):
m_Stack (sc.m_Stack) {

	return;
}

template <class X>
common::SContainer<X>& 
common::SContainer<X>::operator= (const SContainer& sc) {

	m_Stack = sc.m_Stack;
	return *this;
}

template <class X>
common::SContainer<X>::SContainer () {

	return;
}

template <class X>
void common::SContainer<X>::Release () {

	while ( Pop () != NULL ) ;
	return;
}

template <class X>
common::SContainer<X>::~SContainer () {

	return;
}

template <class X>
void common::SContainer<X>::Add (X& x) {
	
	m_Stack.push (&x);
	return;
}

template <class X>
X* common::SContainer<X>::Pop () {

	if ( m_Stack.empty () ) return NULL;
	X* cmd = m_Stack.top ();
	m_Stack.pop ();
	return cmd;
}
		
template <class X>
size_t common::SContainer<X>::GetSize () const {

	return m_Stack.size ();
}
//-----------------------------------------------
#endif /* __scontainer__hpp__ */
