/*
 * Copyright (c) 2010, Boris Popov <popov.b@gmail.com>
 *
 * Permission to use, copy, modify, and/or distribute
 * this software for any purpose with or without fee
 * is hereby granted, provided that the above copyright
 * notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL,
 * DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH
 * THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#include "easysax_common.h"
#include "string_common.h"

Bool IsItWhiteSpace(const char byte)
{
    switch (byte) {

    case '\x20': return Bool_TRUE;
    case '\x09': return Bool_TRUE;
    case '\x0D': return Bool_TRUE;
    case '\x0A': return Bool_TRUE;
    default: return Bool_FALSE;
    }
}


Bool IsItApos(const char ch)
{
    return IsIt(ch, '\'');
}


Bool IsItQuot(const char ch)
{
    return IsIt(ch, '\"');
}


Bool IsItEq(const char ch)
{
    return IsIt(ch, '=');
}


Bool IsItAposOrQuot(const char ch)
{
    return ((IsItApos(ch)) || (IsItQuot(ch)));
}

void Out(void (*out)(const char*, UserData*), const char* ch, UserData* data)
{
    if (out != NULL) out(ch, data);
    return;
}
