/*
 * Copyright (c) 2010, Boris Popov <popov.b@gmail.com>
 *
 * Permission to use, copy, modify, and/or distribute
 * this software for any purpose with or without fee
 * is hereby granted, provided that the above copyright
 * notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL,
 * DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH
 * THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "string_common.h"

#ifndef __esysax_types__h__
#define __esysax_types__h__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef void UserData;
/**
  * @addtogroup Common
  * @{
  */
/** Text */
typedef CString Text;

/** Tag */
typedef CString Tag;

/** Open tag */
typedef Tag OpenTag;

/** Close tag */
typedef Tag CloseTag;

/** Message of error */
typedef CString Error;

/** Attribute name */
typedef CString Attribute_t;

/** Attribute value */
typedef CString Value_t;

/** Structure attribute = "value" */
struct _AttValue
{
    Attribute_t attribute;
    Value_t value;
};

typedef struct _AttValue AttValue;
/** @} */

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* __esysax_types__h__ */
