/*
 * Copyright 2010  Boris Popov <popov.b@gmail.com>
 */

#include "myXML_Document.hpp"


myXML::Attributes::Attributes()
{
    return;
}

myXML::Attributes::~Attributes()
{
    return;
}

bool myXML::Attributes::HasItAttr() const
{
    if (m_ListOfAtt.size() == 0) return false;
    return true;
}

void myXML::Attributes::AddAtt(Attribute at, Value va)
{
    Attr attr;
    attr.att = at;
    attr.val = va;
    m_ListOfAtt.push_back(attr);
    return;
}

myXML::AttrIter myXML::Attributes::Begin()
{
    AttrIter it;
    it.IPA = m_ListOfAtt.begin();
    return it;
}

myXML::AttrIter myXML::Attributes::End()
{
    AttrIter it;
    it.IPA = m_ListOfAtt.end();
    return it;
}

bool myXML::Attributes::DelAtt(Attribute attr)
{
    bool Success = true;
    bool Fault = false;

    if (!HasItAttr()) return Fault;
    AttributesListIterator it = m_GetAtt(attr);
    if (it == m_ListOfAtt.end()) return Fault;
    m_ListOfAtt.erase(it);
    return Success;
}

myXML::AttributesListIterator
myXML::Attributes::m_GetAtt(Attribute attr)
{
    AttributesListIterator it = m_ListOfAtt.begin();
    AttributesListIterator end = m_ListOfAtt.end();

    while (it != end) {

        Attr a = (*it);
        if (a.att == attr) break;
        it++;
    }
    return it;
}

bool myXML::Attributes::GetValueOfAttr(Attribute attr, Value& val)
{
    bool Success = true;
    bool Fault = false;

    if (!HasItAttr()) return Fault;
    AttributesListIterator it = m_GetAtt(attr);
    if (it == m_ListOfAtt.end()) return Fault;
    val = (*it).val;
    return Success;
}

void myXML::Attributes::Clear()
{
    m_ListOfAtt.clear();
    return;
}

myXML::Attributes&
myXML::Attributes::operator=(const Attributes& attributes)
{
    this->m_ListOfAtt = attributes.m_ListOfAtt;
    return (*this);
}
