/*
 * Copyright 2008, 2009, 2010 Boris Popov <popov.b@gmail.com>
 */

#include "myXML_Document.hpp"

//-----------------------------------------------
myXML::Body::Body() :
    Root(new Contain)
{
    (Root->place) = Node::in;
    Root->Set("root");
    return;
}

//-----------------------------------------------

//-----------------------------------------------
myXML::Body::Body(Contain& c)
{
    switch (c.place) {
    case (Node::in):
        {
            Root = &c;
            break;
        }
    case (Node::out):
        {
            //перегнать во внутреннюю
            //структуру
            //создать контейнер
            Root = new Contain;
            Root->Set(c.Get());
            (Root->place) = Node::in;
            //перенести атрибуты
            if (c.GetAttributes().HasItAttr()) {

                (Root->GetAttributes()) = c.GetAttributes();
            }
            //перенос указателей///////////////////////////
            //
            //
            if (!c.ListOfChildren.empty()) {
                std::list<Node*>::iterator p;
                p = (c.ListOfChildren).begin();
                while (p != (c.ListOfChildren).end()) {
                    (Root->ListOfChildren).push_back(*p);
                    (*p)->pParent = Root;
                    p++;
                }
                c.ListOfChildren.clear();
            }
            //
            ///////////////////////////////////////////////
            break;
        }
    case (Node::undef):
        {
            break;
        }
    }
    return;
}

//-----------------------------------------------

//-----------------------------------------------
myXML::Body::~Body()
{
    delete Root;
    return;
}

//-----------------------------------------------

//-----------------------------------------------
myXML::BodyIter myXML::Body::BeginBodyIter()
{
    Node* pN;
    pN = (Node*)Root;
    myXML::BodyIter XBI(pN);
    return XBI;
}

//-----------------------------------------------

//-----------------------------------------------
myXML::BodyIter myXML::Body::EndBodyIter()
{
    Node* pN = 0;
    myXML::BodyIter XBI(pN);
    return XBI;
}

//-----------------------------------------------

//-----------------------------------------------
void myXML::Body::DelNode(myXML::BodyIter& i)
{
    Node* pN;
    pN = i.pNode;
    delnode(pN);
    return;
}

//-----------------------------------------------

//-----------------------------------------------
void
myXML::Body::delnode(Node* pN)
{
    if (pN == Root) {
        std::list<Node*>::iterator p;
        Contain* pC = (Contain*)pN;
        p = (pC->ListOfChildren).begin();
        while (p != (pC->ListOfChildren).end()) {
            delete (*p);
            p++;
        }
        pC->ListOfChildren.clear();
    }
    else {
        Contain* pC;
        pC = pN->pParent;
        std::list<Node*>::iterator p;
        p = (pC->ListOfChildren).begin();
        while (p != (pC->ListOfChildren).end()) {
            if ((*p) == pN) {
                break;
            }
            p++;
        }
        (pC->ListOfChildren).erase(p);
        delete pN;
    }
    return;
}

//-----------------------------------------------

//-----------------------------------------------
void myXML::Body::DelNode(Contain& cn)
{
    Node* pN;
    pN = (Node*)(&cn);
    delnode(pN);
    return;
}

//-----------------------------------------------

//-----------------------------------------------
void
myXML::Body::DelNode(Text& tx)
{
    Node* pN;
    pN = (Node*)(&tx);
    delnode(pN);
    return;
}

//-----------------------------------------------
