/*
 * Copyright 2008, 2010 Boris Popov <popov.b@gmail.com>
 */

#include "myXML_Document.hpp"

myXML::BodyIter::BodyIter(const myXML::BodyIter& bi)
{
    this->pNode = bi.pNode;
    return;
}

myXML::BodyIter&
myXML::BodyIter::operator=(const myXML::BodyIter& bi)
{
    this->pNode = bi.pNode;
    return *this;
}

myXML::BodyIter::BodyIter(Node* pN)
{
    pNode = pN;
    return;
}

myXML::BodyIter::BodyIter()
{
    return;
}

myXML::Node* myXML::BodyIter::operator *()
{
    return pNode;
}

myXML::BodyIter&
myXML::BodyIter::operator ++()
{
    if (pNode == 0) {
        return *this;
    }

    pNode = plus_normal_iter();
    return *this;
}

myXML::Node* myXML::BodyIter::plus_normal_iter()
{
    Node* pN;
    if ((pNode->GetType()) == myXML::Document::Container) {
        //это только к контейнерам
        Contain* pC = (Contain*)(pNode);
        if (!((pC->ListOfChildren).empty())) {
            std::list<Node*>::iterator p;
            p = (pC->ListOfChildren).begin();
            while (p != ((pC->ListOfChildren).end())) {
                Queue.push(*p);
                p++;
            }
        }
    }
    if (!Queue.empty()) {
        pN = Queue.front();
        Queue.pop();
    }
    else {
        pN = 0;
    }
    return pN;
}

//===============================================
bool myXML::operator !=(myXML::BodyIter a, myXML::BodyIter b)
{
    if (a.pNode != b.pNode) {
        return true;
    }
    return false;
}

//===============================================

//===============================================
bool myXML::operator ==(myXML::BodyIter a, myXML::BodyIter b)
{
    if (a.pNode == b.pNode) {
        return true;
    }
    return false;
}

//===============================================
