/*
 * Copyright 2008, 2009, 2010  Boris Popov <popov.b@gmail.com>
 */

#include "myXML_Document.hpp"
#include "myXML_Mirroring.hpp"
#include <easysax.h>
#include <stack>

#ifndef __xmlbuildoftree_hpp__
#define __xmlbuildoftree_hpp__

namespace myXML
{
    struct BuildOfTreeResult
    {
        myXML::Declar* declar;
        myXML::Contain* cont;
        String* messg;
    };

    class BuildOfTree
    {
    public:
        BuildOfTree();

        void Make_open_teg(const char* t);
        void Make_close_teg(const char* t);
        void Make_text(const char* t);
        void Put_att(AttValue);
        void Put_message(const char* t);
        void Make_decl();
        BuildOfTreeResult get();


    private:

        void make_open_teg(String t);
        void make_close_teg(String t);
        void make_null_teg(String t);
        void make_text(String t);
        void put_att(String a,
                     String v);
        void make_decl();


        std::stack<myXML::Contain*> container;
        String message;
        myXML::Declar* xmldeclar;
        myXML::Contain* root;
        myXML::Contain* last_container;
        bool zero_xmldeclar;
        bool last_in_declar;

        mr::FromMirror m_fMirror;
        bool m_IsItDelimiter(const char ch);
        String clear_from_delim(String what);

        BuildOfTree(const BuildOfTree&);
        BuildOfTree& operator=(const BuildOfTree&);
    };
}
#endif
