/*
 * Copyright 2008, 2010 Boris Popov <popov.b@gmail.com>
 */

#include "myXML_Builder.hpp"

//-----------------------------------------------
myXML::String myXML::Builder::COM1 = "<!--";
myXML::String myXML::Builder::COM2 = "-->";
//-----------------------------------------------

//-----------------------------------------------
myXML::Builder::Builder(myXML::Prolog& Prolog, myXML::Body& Body) :
    bop(*(new BuilderOfProlog(Prolog))),
    body(Body)
{
    return;
}

//-----------------------------------------------

//-----------------------------------------------
myXML::Builder::~Builder()
{
    delete &bop;
    return;
}

//-----------------------------------------------

//-----------------------------------------------
myXML::String myXML::Builder::Get()
{
    return bop.Get() + ((body.Root->build()));
}

//-----------------------------------------------

/*
 *
 * Построитель текстового
 * представления пролога из
 * объектной структуры.
 *
 */

//-----------------------------------------------
myXML::String myXML::BuilderOfProlog::DECL1 = "<?xml";
myXML::String myXML::BuilderOfProlog::DECL2 = " ?>";
//-----------------------------------------------

//-----------------------------------------------
myXML::BuilderOfProlog::BuilderOfProlog(myXML::Prolog& Prolog) :
    bop(Prolog)
{
    return;
}

//-----------------------------------------------

//-----------------------------------------------
myXML::BuilderOfProlog::~BuilderOfProlog()
{
    return;
}

//-----------------------------------------------

//-----------------------------------------------
myXML::String myXML::BuilderOfProlog::Get()
{
    String declar;
    declar = get_declar();
    return declar;
}

//-----------------------------------------------

//-----------------------------------------------
myXML::String myXML::BuilderOfProlog::get_declar()
{
    String temp;
    myXML::Declar& tempDeclar = bop.GetDeclar();
    if (!tempDeclar.IsItEnabled()) return temp;

    String attr;

    AttrIter p;
    p = (tempDeclar.GetAttributes()).Begin();
    AttrIter end;
    end = (tempDeclar.GetAttributes()).End();

    while (p != end) {
        attr = attr + " " + (p.Get()).att +
            "=\"" + (p.Get()).val +
            "\"";
        ++p;
    }
    String comment_after_decl;
    temp = DECL1 + attr + DECL2 + "\n";
    return temp;
}

//-----------------------------------------------
