/*
 * Copyright 2008, 2010 Boris Popov <popov.b@gmail.com>
 */

/*
 *
 * Построитель текстового
 * представления из
 * объектной структуры.
 *
 */

#include "myXML_Document.hpp"

#ifndef __xmlbuilder_hpp__
#define __xmlbuilder_hpp__

//-----------------------------------------------
namespace myXML
{
    class BuilderOfProlog;

    class Builder
    {
    public:
        Builder(myXML::Prolog&, myXML::Body&);
        ~Builder();

        String Get();
    private:
        BuilderOfProlog& bop;
        Body& body;
        static String COM1;
        static String COM2;

        Builder(const Builder&);
        Builder& operator=(const Builder&);
    };
}

//-----------------------------------------------

//-----------------------------------------------
namespace myXML
{
    class BuilderOfProlog
    {
    public:
        BuilderOfProlog(myXML::Prolog&);
        ~BuilderOfProlog();
        String Get();
    private:
        myXML::Prolog& bop;
        String get_declar();
        static String DECL1;
        static String DECL2;

        BuilderOfProlog(const BuilderOfProlog&);
        BuilderOfProlog& operator=(const BuilderOfProlog&);
    };
}

//-----------------------------------------------
#endif
