/*
 * Copyright 2008, 2009, 2010 Boris Popov <popov.b@gmail.com>
 */

#include "myXML_Document.hpp"
#include "myXML_Builder.hpp"
#include "myXML_Parser.hpp"

//-----------------------------------------------
myXML::Document::Document() :
    m_InputString(NULL)
{
    return;
}

//-----------------------------------------------

//-----------------------------------------------
myXML::Document::Document(Contain& c) :
    m_Body(c),
    m_InputString(NULL)
{
    return;
}

//-----------------------------------------------

//-----------------------------------------------
void myXML::Document::m_ParseString()
{
    if (m_InputString == NULL) {

        return;
    }

    Parser parser(m_InputString);
    ParserResult ParsRes;
    ParsRes = parser.Get();

    if (ParsRes.messg == "") {

        correct(ParsRes);
    }

    return;
}

//-----------------------------------------------

//-----------------------------------------------
bool myXML::Document::LoadFile(FileName fn)
{
    message = "";
    bool flag;
    Parser* pParser;
    pParser = new Parser(fn.c_str());
    ParserResult ParsRes;
    ParsRes = pParser->GetFromFile();
    if (ParsRes.messg != "") {
        flag = false;
        message = ParsRes.messg;
    }
    else {
        flag = true;
        //откорректировать
        //структуру документа
        //согласно
        //загруженному.
        correct(ParsRes);
    }
    delete pParser;
    return flag;
}

bool myXML::Document::LoadStringX(CString string)
{
    message = "";
    bool Success = true;
    bool Fault = false;
    bool RESULT = Fault;

    Parser parser(string);
    ParserResult ParsRes;
    ParsRes = parser.Get();

    if (ParsRes.messg != "") {

        message = ParsRes.messg;

    }
    else {

        RESULT = Success;
        correct(ParsRes);
    }
    return RESULT;
}

bool myXML::Document::LoadStdin()
{
    message = "";
    bool Success = true;
    bool Fault = false;
    bool RESULT = Fault;

    Parser parser;
    ParserResult ParsRes;
    ParsRes = parser.Get();

    if (ParsRes.messg != "") {

        message = ParsRes.messg;

    }
    else {

        RESULT = Success;
        correct(ParsRes);
    }
    return RESULT;
}

//-----------------------------------------------
myXML::Document::~Document()
{
    return;
}

//-----------------------------------------------

myXML::String myXML::Document::Get()
{
    myXML::Builder b(m_Prolog, m_Body);
    return b.Get();
}

//-----------------------------------------------
myXML::String myXML::Document::GetMessage() const
{
    return message;
}

//-----------------------------------------------

//-----------------------------------------------
void myXML::Document::correct(ParserResult pr)
{
    delete m_Body.Root;
    m_Body.Root = pr.cont;


    ////декларация
    if (pr.declar == 0) {
        //отключить декларацию
        m_Prolog.GetDeclar().UnSet();
    }
    else {

        Attributes& newatt = (pr.declar)->GetAttributes();
        newatt.DelAtt("version");
        m_Prolog.GetDeclar().Set();
        m_Prolog.GetDeclar().GetAttributes() = newatt;
        delete pr.declar;
    }
    ////
    return;
}

//-----------------------------------------------

//-----------------------------------------------
myXML::Prolog& myXML::Document::GetProlog()
{
    return m_Prolog;
}

//-----------------------------------------------

//-----------------------------------------------
myXML::Body& myXML::Document::GetBody()
{
    return m_Body;
}

//-----------------------------------------------

//-----------------------------------------------
myXML::Document& myXML::Document::operator =(myXML::Document& d)
{
    d.GetMessage();
    return *this;
}

//-----------------------------------------------
