/*
 * Copyright 2008, 2009, 2010  Boris Popov <popov.b@gmail.com>
 */

#include <easysax.h>
#include <cstdio>
#include "myXML_BuildOfTree.hpp"

#ifndef __xmlparser_hpp__
#define __xmlparser_hpp__

namespace myXML
{
    struct ParserResult
    {
        Declar* declar;
        Contain* cont;
        String messg;
    };

    class Parser
    {
    public:
        Parser(const char* ch);
        Parser();
        ~Parser();
        ParserResult Get();
        ParserResult GetFromFile();

        BuildOfTree xbot;

    private:

        const char* m_InputString;
        String message;

        ParserResult m_Result;
        void m_InitResult();

        Parser(const Parser&);
        Parser& operator=(const Parser&);
        ParserResult m_GetFromStdin();
    };
}
#endif
